pragma Warnings (Off);
pragma Ada_95;
with System;
with System.Parameters;
with System.Secondary_Stack;
package ada_main is

   gnat_argc : Integer;
   gnat_argv : System.Address;
   gnat_envp : System.Address;

   pragma Import (C, gnat_argc);
   pragma Import (C, gnat_argv);
   pragma Import (C, gnat_envp);

   gnat_exit_status : Integer;
   pragma Import (C, gnat_exit_status);

   GNAT_Version : constant String :=
                    "GNAT Version: 10.4.0" & ASCII.NUL;
   pragma Export (C, GNAT_Version, "__gnat_version");

   Ada_Main_Program_Name : constant String := "_ada_gnatbind" & ASCII.NUL;
   pragma Export (C, Ada_Main_Program_Name, "__gnat_ada_main_program_name");

   procedure adainit;
   pragma Export (C, adainit, "adainit");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer;
   pragma Export (C, main, "main");

   type Version_32 is mod 2 ** 32;
   u00001 : constant Version_32 := 16#31374c26#;
   pragma Export (C, u00001, "gnatbindB");
   u00002 : constant Version_32 := 16#d6787f71#;
   pragma Export (C, u00002, "gnatbindS");
   u00003 : constant Version_32 := 16#050ff2f0#;
   pragma Export (C, u00003, "system__standard_libraryB");
   u00004 : constant Version_32 := 16#c479c686#;
   pragma Export (C, u00004, "system__standard_libraryS");
   u00005 : constant Version_32 := 16#9d3a214a#;
   pragma Export (C, u00005, "ada__exceptionsB");
   u00006 : constant Version_32 := 16#533dbf06#;
   pragma Export (C, u00006, "ada__exceptionsS");
   u00007 : constant Version_32 := 16#76789da1#;
   pragma Export (C, u00007, "adaS");
   u00008 : constant Version_32 := 16#5726abed#;
   pragma Export (C, u00008, "ada__exceptions__last_chance_handlerB");
   u00009 : constant Version_32 := 16#cfec26ee#;
   pragma Export (C, u00009, "ada__exceptions__last_chance_handlerS");
   u00010 : constant Version_32 := 16#c35fd8a9#;
   pragma Export (C, u00010, "systemS");
   u00011 : constant Version_32 := 16#ae860117#;
   pragma Export (C, u00011, "system__soft_linksB");
   u00012 : constant Version_32 := 16#0855a0df#;
   pragma Export (C, u00012, "system__soft_linksS");
   u00013 : constant Version_32 := 16#7641759e#;
   pragma Export (C, u00013, "system__secondary_stackB");
   u00014 : constant Version_32 := 16#86cb20b0#;
   pragma Export (C, u00014, "system__secondary_stackS");
   u00015 : constant Version_32 := 16#86dbf443#;
   pragma Export (C, u00015, "system__parametersB");
   u00016 : constant Version_32 := 16#8bb38c82#;
   pragma Export (C, u00016, "system__parametersS");
   u00017 : constant Version_32 := 16#ced09590#;
   pragma Export (C, u00017, "system__storage_elementsB");
   u00018 : constant Version_32 := 16#ee9c92ad#;
   pragma Export (C, u00018, "system__storage_elementsS");
   u00019 : constant Version_32 := 16#75bf515c#;
   pragma Export (C, u00019, "system__soft_links__initializeB");
   u00020 : constant Version_32 := 16#5697fc2b#;
   pragma Export (C, u00020, "system__soft_links__initializeS");
   u00021 : constant Version_32 := 16#41837d1e#;
   pragma Export (C, u00021, "system__stack_checkingB");
   u00022 : constant Version_32 := 16#4de0b341#;
   pragma Export (C, u00022, "system__stack_checkingS");
   u00023 : constant Version_32 := 16#34742901#;
   pragma Export (C, u00023, "system__exception_tableB");
   u00024 : constant Version_32 := 16#9ef1b1eb#;
   pragma Export (C, u00024, "system__exception_tableS");
   u00025 : constant Version_32 := 16#ce4af020#;
   pragma Export (C, u00025, "system__exceptionsB");
   u00026 : constant Version_32 := 16#ab3cb55f#;
   pragma Export (C, u00026, "system__exceptionsS");
   u00027 : constant Version_32 := 16#69416224#;
   pragma Export (C, u00027, "system__exceptions__machineB");
   u00028 : constant Version_32 := 16#5c74e542#;
   pragma Export (C, u00028, "system__exceptions__machineS");
   u00029 : constant Version_32 := 16#aa0563fc#;
   pragma Export (C, u00029, "system__exceptions_debugB");
   u00030 : constant Version_32 := 16#bdd5216d#;
   pragma Export (C, u00030, "system__exceptions_debugS");
   u00031 : constant Version_32 := 16#6c2f8802#;
   pragma Export (C, u00031, "system__img_intB");
   u00032 : constant Version_32 := 16#c184386b#;
   pragma Export (C, u00032, "system__img_intS");
   u00033 : constant Version_32 := 16#39df8c17#;
   pragma Export (C, u00033, "system__tracebackB");
   u00034 : constant Version_32 := 16#9d7d066d#;
   pragma Export (C, u00034, "system__tracebackS");
   u00035 : constant Version_32 := 16#9ed49525#;
   pragma Export (C, u00035, "system__traceback_entriesB");
   u00036 : constant Version_32 := 16#c3042ed9#;
   pragma Export (C, u00036, "system__traceback_entriesS");
   u00037 : constant Version_32 := 16#bb296fbb#;
   pragma Export (C, u00037, "system__traceback__symbolicB");
   u00038 : constant Version_32 := 16#46491211#;
   pragma Export (C, u00038, "system__traceback__symbolicS");
   u00039 : constant Version_32 := 16#701f9d88#;
   pragma Export (C, u00039, "ada__exceptions__tracebackB");
   u00040 : constant Version_32 := 16#ae2d2db5#;
   pragma Export (C, u00040, "ada__exceptions__tracebackS");
   u00041 : constant Version_32 := 16#a0d3d22b#;
   pragma Export (C, u00041, "system__address_imageB");
   u00042 : constant Version_32 := 16#62b34593#;
   pragma Export (C, u00042, "system__address_imageS");
   u00043 : constant Version_32 := 16#8c33a517#;
   pragma Export (C, u00043, "system__wch_conB");
   u00044 : constant Version_32 := 16#d822fa7b#;
   pragma Export (C, u00044, "system__wch_conS");
   u00045 : constant Version_32 := 16#9721e840#;
   pragma Export (C, u00045, "system__wch_stwB");
   u00046 : constant Version_32 := 16#f533d67a#;
   pragma Export (C, u00046, "system__wch_stwS");
   u00047 : constant Version_32 := 16#a831679c#;
   pragma Export (C, u00047, "system__wch_cnvB");
   u00048 : constant Version_32 := 16#d7954088#;
   pragma Export (C, u00048, "system__wch_cnvS");
   u00049 : constant Version_32 := 16#5ab55268#;
   pragma Export (C, u00049, "interfacesS");
   u00050 : constant Version_32 := 16#ece6fdb6#;
   pragma Export (C, u00050, "system__wch_jisB");
   u00051 : constant Version_32 := 16#57e559a9#;
   pragma Export (C, u00051, "system__wch_jisS");
   u00052 : constant Version_32 := 16#abfcab7d#;
   pragma Export (C, u00052, "aliB");
   u00053 : constant Version_32 := 16#4f5456e6#;
   pragma Export (C, u00053, "aliS");
   u00054 : constant Version_32 := 16#c017f602#;
   pragma Export (C, u00054, "butilB");
   u00055 : constant Version_32 := 16#0d752381#;
   pragma Export (C, u00055, "butilS");
   u00056 : constant Version_32 := 16#b5988c27#;
   pragma Export (C, u00056, "gnatS");
   u00057 : constant Version_32 := 16#0181b2d9#;
   pragma Export (C, u00057, "optB");
   u00058 : constant Version_32 := 16#5897096d#;
   pragma Export (C, u00058, "optS");
   u00059 : constant Version_32 := 16#5d525d24#;
   pragma Export (C, u00059, "gnatvsnB");
   u00060 : constant Version_32 := 16#aed2d083#;
   pragma Export (C, u00060, "gnatvsnS");
   u00061 : constant Version_32 := 16#b9a3a899#;
   pragma Export (C, u00061, "tree_ioB");
   u00062 : constant Version_32 := 16#269c4d2f#;
   pragma Export (C, u00062, "tree_ioS");
   u00063 : constant Version_32 := 16#91fc5baa#;
   pragma Export (C, u00063, "debugB");
   u00064 : constant Version_32 := 16#1ac546f9#;
   pragma Export (C, u00064, "debugS");
   u00065 : constant Version_32 := 16#39794d05#;
   pragma Export (C, u00065, "outputB");
   u00066 : constant Version_32 := 16#83393876#;
   pragma Export (C, u00066, "outputS");
   u00067 : constant Version_32 := 16#7db849eb#;
   pragma Export (C, u00067, "hostparmS");
   u00068 : constant Version_32 := 16#fd83e873#;
   pragma Export (C, u00068, "system__concat_2B");
   u00069 : constant Version_32 := 16#c1ff0f79#;
   pragma Export (C, u00069, "system__concat_2S");
   u00070 : constant Version_32 := 16#587eb9ab#;
   pragma Export (C, u00070, "typesB");
   u00071 : constant Version_32 := 16#f781bf31#;
   pragma Export (C, u00071, "typesS");
   u00072 : constant Version_32 := 16#acee74ad#;
   pragma Export (C, u00072, "system__compare_array_unsigned_8B");
   u00073 : constant Version_32 := 16#6a5ca924#;
   pragma Export (C, u00073, "system__compare_array_unsigned_8S");
   u00074 : constant Version_32 := 16#a8025f3c#;
   pragma Export (C, u00074, "system__address_operationsB");
   u00075 : constant Version_32 := 16#d053669a#;
   pragma Export (C, u00075, "system__address_operationsS");
   u00076 : constant Version_32 := 16#f7d9a42a#;
   pragma Export (C, u00076, "system__unsigned_typesS");
   u00077 : constant Version_32 := 16#d1283fcd#;
   pragma Export (C, u00077, "system__os_libB");
   u00078 : constant Version_32 := 16#d872da39#;
   pragma Export (C, u00078, "system__os_libS");
   u00079 : constant Version_32 := 16#ec4d5631#;
   pragma Export (C, u00079, "system__case_utilB");
   u00080 : constant Version_32 := 16#fc8a6efd#;
   pragma Export (C, u00080, "system__case_utilS");
   u00081 : constant Version_32 := 16#850857f3#;
   pragma Export (C, u00081, "system__crtlS");
   u00082 : constant Version_32 := 16#2a8e89ad#;
   pragma Export (C, u00082, "system__stringsB");
   u00083 : constant Version_32 := 16#a349f43c#;
   pragma Export (C, u00083, "system__stringsS");
   u00084 : constant Version_32 := 16#88e79fef#;
   pragma Export (C, u00084, "nametB");
   u00085 : constant Version_32 := 16#f1c61094#;
   pragma Export (C, u00085, "nametS");
   u00086 : constant Version_32 := 16#700bac7f#;
   pragma Export (C, u00086, "widecharB");
   u00087 : constant Version_32 := 16#700d44f3#;
   pragma Export (C, u00087, "widecharS");
   u00088 : constant Version_32 := 16#972e59bd#;
   pragma Export (C, u00088, "allocS");
   u00089 : constant Version_32 := 16#7225e28b#;
   pragma Export (C, u00089, "tableB");
   u00090 : constant Version_32 := 16#71c45158#;
   pragma Export (C, u00090, "tableS");
   u00091 : constant Version_32 := 16#e31b7c4e#;
   pragma Export (C, u00091, "system__memoryB");
   u00092 : constant Version_32 := 16#9a22be9d#;
   pragma Export (C, u00092, "system__memoryS");
   u00093 : constant Version_32 := 16#e909d55e#;
   pragma Export (C, u00093, "fnameB");
   u00094 : constant Version_32 := 16#06dc2a66#;
   pragma Export (C, u00094, "fnameS");
   u00095 : constant Version_32 := 16#2044a70d#;
   pragma Export (C, u00095, "gnat__dynamic_htablesB");
   u00096 : constant Version_32 := 16#05f952b6#;
   pragma Export (C, u00096, "gnat__dynamic_htablesS");
   u00097 : constant Version_32 := 16#17fb561a#;
   pragma Export (C, u00097, "osintB");
   u00098 : constant Version_32 := 16#d558ad92#;
   pragma Export (C, u00098, "osintS");
   u00099 : constant Version_32 := 16#c4507fa7#;
   pragma Export (C, u00099, "fmapB");
   u00100 : constant Version_32 := 16#9ac5a2f6#;
   pragma Export (C, u00100, "fmapS");
   u00101 : constant Version_32 := 16#be789e08#;
   pragma Export (C, u00101, "gnat__htableB");
   u00102 : constant Version_32 := 16#7a3e0440#;
   pragma Export (C, u00102, "gnat__htableS");
   u00103 : constant Version_32 := 16#796f31f1#;
   pragma Export (C, u00103, "system__htableB");
   u00104 : constant Version_32 := 16#479d6b43#;
   pragma Export (C, u00104, "system__htableS");
   u00105 : constant Version_32 := 16#089f5cd0#;
   pragma Export (C, u00105, "system__string_hashB");
   u00106 : constant Version_32 := 16#e5c3003d#;
   pragma Export (C, u00106, "system__string_hashS");
   u00107 : constant Version_32 := 16#b910cc1d#;
   pragma Export (C, u00107, "sdefaultB");
   u00108 : constant Version_32 := 16#a7d7201f#;
   pragma Export (C, u00108, "sdefaultS");
   u00109 : constant Version_32 := 16#40dce533#;
   pragma Export (C, u00109, "targparmB");
   u00110 : constant Version_32 := 16#24210956#;
   pragma Export (C, u00110, "targparmS");
   u00111 : constant Version_32 := 16#46a3369a#;
   pragma Export (C, u00111, "csetsB");
   u00112 : constant Version_32 := 16#e948558f#;
   pragma Export (C, u00112, "csetsS");
   u00113 : constant Version_32 := 16#27e30df3#;
   pragma Export (C, u00113, "ridentS");
   u00114 : constant Version_32 := 16#a19d6876#;
   pragma Export (C, u00114, "snamesB");
   u00115 : constant Version_32 := 16#2b47cd92#;
   pragma Export (C, u00115, "snamesS");
   u00116 : constant Version_32 := 16#cfbc3039#;
   pragma Export (C, u00116, "casingB");
   u00117 : constant Version_32 := 16#f1067a43#;
   pragma Export (C, u00117, "casingS");
   u00118 : constant Version_32 := 16#c0b19ae7#;
   pragma Export (C, u00118, "ali__utilB");
   u00119 : constant Version_32 := 16#cd7c7b7f#;
   pragma Export (C, u00119, "ali__utilS");
   u00120 : constant Version_32 := 16#a38bdc57#;
   pragma Export (C, u00120, "atreeB");
   u00121 : constant Version_32 := 16#016149e3#;
   pragma Export (C, u00121, "atreeS");
   u00122 : constant Version_32 := 16#04c990f1#;
   pragma Export (C, u00122, "aspectsB");
   u00123 : constant Version_32 := 16#479df97c#;
   pragma Export (C, u00123, "aspectsS");
   u00124 : constant Version_32 := 16#186f7a0d#;
   pragma Export (C, u00124, "einfoB");
   u00125 : constant Version_32 := 16#6f09bdd8#;
   pragma Export (C, u00125, "einfoS");
   u00126 : constant Version_32 := 16#4ddf0b23#;
   pragma Export (C, u00126, "elistsB");
   u00127 : constant Version_32 := 16#35757bed#;
   pragma Export (C, u00127, "elistsS");
   u00128 : constant Version_32 := 16#1b6610ed#;
   pragma Export (C, u00128, "nlistsB");
   u00129 : constant Version_32 := 16#13d47728#;
   pragma Export (C, u00129, "nlistsS");
   u00130 : constant Version_32 := 16#40954c32#;
   pragma Export (C, u00130, "sinfoB");
   u00131 : constant Version_32 := 16#d099103f#;
   pragma Export (C, u00131, "sinfoS");
   u00132 : constant Version_32 := 16#92a723ac#;
   pragma Export (C, u00132, "uintpB");
   u00133 : constant Version_32 := 16#20eb23c2#;
   pragma Export (C, u00133, "uintpS");
   u00134 : constant Version_32 := 16#b13f2662#;
   pragma Export (C, u00134, "urealpB");
   u00135 : constant Version_32 := 16#fcb52a52#;
   pragma Export (C, u00135, "urealpS");
   u00136 : constant Version_32 := 16#0fc269a6#;
   pragma Export (C, u00136, "standB");
   u00137 : constant Version_32 := 16#97e61926#;
   pragma Export (C, u00137, "standS");
   u00138 : constant Version_32 := 16#8539d2d8#;
   pragma Export (C, u00138, "sinputB");
   u00139 : constant Version_32 := 16#5c3727db#;
   pragma Export (C, u00139, "sinputS");
   u00140 : constant Version_32 := 16#f546f02e#;
   pragma Export (C, u00140, "gnat__byte_order_markB");
   u00141 : constant Version_32 := 16#9e8b3c0b#;
   pragma Export (C, u00141, "gnat__byte_order_markS");
   u00142 : constant Version_32 := 16#c34fe37c#;
   pragma Export (C, u00142, "scansB");
   u00143 : constant Version_32 := 16#5f34a5f0#;
   pragma Export (C, u00143, "scansS");
   u00144 : constant Version_32 := 16#dd938547#;
   pragma Export (C, u00144, "binderrB");
   u00145 : constant Version_32 := 16#070d98dd#;
   pragma Export (C, u00145, "binderrS");
   u00146 : constant Version_32 := 16#fbb8363e#;
   pragma Export (C, u00146, "err_varsS");
   u00147 : constant Version_32 := 16#8a1a8848#;
   pragma Export (C, u00147, "restrictB");
   u00148 : constant Version_32 := 16#4d64c5da#;
   pragma Export (C, u00148, "restrictS");
   u00149 : constant Version_32 := 16#eed4cb97#;
   pragma Export (C, u00149, "erroutB");
   u00150 : constant Version_32 := 16#34450fad#;
   pragma Export (C, u00150, "erroutS");
   u00151 : constant Version_32 := 16#02f590fe#;
   pragma Export (C, u00151, "erroutcB");
   u00152 : constant Version_32 := 16#34c69e85#;
   pragma Export (C, u00152, "erroutcS");
   u00153 : constant Version_32 := 16#092ce8de#;
   pragma Export (C, u00153, "stringtB");
   u00154 : constant Version_32 := 16#f94e8e05#;
   pragma Export (C, u00154, "stringtS");
   u00155 : constant Version_32 := 16#9a737387#;
   pragma Export (C, u00155, "libB");
   u00156 : constant Version_32 := 16#805e10cc#;
   pragma Export (C, u00156, "libS");
   u00157 : constant Version_32 := 16#a4214150#;
   pragma Export (C, u00157, "unameB");
   u00158 : constant Version_32 := 16#7ba289ea#;
   pragma Export (C, u00158, "unameS");
   u00159 : constant Version_32 := 16#999198a6#;
   pragma Export (C, u00159, "sem_auxB");
   u00160 : constant Version_32 := 16#9f4dc9af#;
   pragma Export (C, u00160, "sem_auxS");
   u00161 : constant Version_32 := 16#933d538f#;
   pragma Export (C, u00161, "styleswB");
   u00162 : constant Version_32 := 16#bce761ee#;
   pragma Export (C, u00162, "styleswS");
   u00163 : constant Version_32 := 16#73c1f60f#;
   pragma Export (C, u00163, "fname__ufB");
   u00164 : constant Version_32 := 16#76bbb8a3#;
   pragma Export (C, u00164, "fname__ufS");
   u00165 : constant Version_32 := 16#997d3593#;
   pragma Export (C, u00165, "krunchB");
   u00166 : constant Version_32 := 16#c0b4ff65#;
   pragma Export (C, u00166, "krunchS");
   u00167 : constant Version_32 := 16#d642a37a#;
   pragma Export (C, u00167, "scngB");
   u00168 : constant Version_32 := 16#5f4ca81a#;
   pragma Export (C, u00168, "scngS");
   u00169 : constant Version_32 := 16#1c868fea#;
   pragma Export (C, u00169, "system__crc32B");
   u00170 : constant Version_32 := 16#7a4d0206#;
   pragma Export (C, u00170, "system__crc32S");
   u00171 : constant Version_32 := 16#27ccf663#;
   pragma Export (C, u00171, "system__utf_32B");
   u00172 : constant Version_32 := 16#5dd63165#;
   pragma Export (C, u00172, "system__utf_32S");
   u00173 : constant Version_32 := 16#3f14c101#;
   pragma Export (C, u00173, "stylegB");
   u00174 : constant Version_32 := 16#a75c9028#;
   pragma Export (C, u00174, "stylegS");
   u00175 : constant Version_32 := 16#43370185#;
   pragma Export (C, u00175, "sinput__cB");
   u00176 : constant Version_32 := 16#ae235f22#;
   pragma Export (C, u00176, "sinput__cS");
   u00177 : constant Version_32 := 16#3dc4fc67#;
   pragma Export (C, u00177, "bcheckB");
   u00178 : constant Version_32 := 16#881dacd4#;
   pragma Export (C, u00178, "bcheckS");
   u00179 : constant Version_32 := 16#efb8d423#;
   pragma Export (C, u00179, "bindgenB");
   u00180 : constant Version_32 := 16#fb0e24e6#;
   pragma Export (C, u00180, "bindgenS");
   u00181 : constant Version_32 := 16#971572dd#;
   pragma Export (C, u00181, "gnat__heap_sort_aB");
   u00182 : constant Version_32 := 16#0e248684#;
   pragma Export (C, u00182, "gnat__heap_sort_aS");
   u00183 : constant Version_32 := 16#9a918a6b#;
   pragma Export (C, u00183, "osint__bB");
   u00184 : constant Version_32 := 16#aa8d3012#;
   pragma Export (C, u00184, "osint__bS");
   u00185 : constant Version_32 := 16#7d805f44#;
   pragma Export (C, u00185, "bindoB");
   u00186 : constant Version_32 := 16#2f7e3947#;
   pragma Export (C, u00186, "bindoS");
   u00187 : constant Version_32 := 16#3eb7f69e#;
   pragma Export (C, u00187, "bindeB");
   u00188 : constant Version_32 := 16#7e2c0de3#;
   pragma Export (C, u00188, "bindeS");
   u00189 : constant Version_32 := 16#91556746#;
   pragma Export (C, u00189, "bindo__elaboratorsB");
   u00190 : constant Version_32 := 16#45d69c14#;
   pragma Export (C, u00190, "bindo__elaboratorsS");
   u00191 : constant Version_32 := 16#c0709b8b#;
   pragma Export (C, u00191, "bindo__augmentorsB");
   u00192 : constant Version_32 := 16#381c47ad#;
   pragma Export (C, u00192, "bindo__augmentorsS");
   u00193 : constant Version_32 := 16#726b7a40#;
   pragma Export (C, u00193, "bindo__writersB");
   u00194 : constant Version_32 := 16#83f7d6d2#;
   pragma Export (C, u00194, "bindo__writersS");
   u00195 : constant Version_32 := 16#0426d861#;
   pragma Export (C, u00195, "bindo__unitsB");
   u00196 : constant Version_32 := 16#02e8d8ea#;
   pragma Export (C, u00196, "bindo__unitsS");
   u00197 : constant Version_32 := 16#6fec6580#;
   pragma Export (C, u00197, "gnat__setsB");
   u00198 : constant Version_32 := 16#d4fca1b1#;
   pragma Export (C, u00198, "gnat__setsS");
   u00199 : constant Version_32 := 16#de8cdcd4#;
   pragma Export (C, u00199, "gnat__graphsB");
   u00200 : constant Version_32 := 16#4a2a0f3d#;
   pragma Export (C, u00200, "gnat__graphsS");
   u00201 : constant Version_32 := 16#21be9788#;
   pragma Export (C, u00201, "gnat__listsB");
   u00202 : constant Version_32 := 16#00c03999#;
   pragma Export (C, u00202, "gnat__listsS");
   u00203 : constant Version_32 := 16#541d8326#;
   pragma Export (C, u00203, "bindo__graphsB");
   u00204 : constant Version_32 := 16#5f9b3d45#;
   pragma Export (C, u00204, "bindo__graphsS");
   u00205 : constant Version_32 := 16#40e999ca#;
   pragma Export (C, u00205, "bindo__buildersB");
   u00206 : constant Version_32 := 16#e035a148#;
   pragma Export (C, u00206, "bindo__buildersS");
   u00207 : constant Version_32 := 16#03842744#;
   pragma Export (C, u00207, "bindo__validatorsB");
   u00208 : constant Version_32 := 16#afc9a2bf#;
   pragma Export (C, u00208, "bindo__validatorsS");
   u00209 : constant Version_32 := 16#fd8b0efa#;
   pragma Export (C, u00209, "bindo__diagnosticsB");
   u00210 : constant Version_32 := 16#8c83105e#;
   pragma Export (C, u00210, "bindo__diagnosticsS");
   u00211 : constant Version_32 := 16#59cac51d#;
   pragma Export (C, u00211, "bindusgB");
   u00212 : constant Version_32 := 16#12f067e3#;
   pragma Export (C, u00212, "bindusgS");
   u00213 : constant Version_32 := 16#a88c6d24#;
   pragma Export (C, u00213, "switchB");
   u00214 : constant Version_32 := 16#cb06ad41#;
   pragma Export (C, u00214, "switchS");
   u00215 : constant Version_32 := 16#03b8c86c#;
   pragma Export (C, u00215, "switch__bB");
   u00216 : constant Version_32 := 16#2c145cac#;
   pragma Export (C, u00216, "switch__bS");
   u00217 : constant Version_32 := 16#ea932337#;
   pragma Export (C, u00217, "system__response_fileB");
   u00218 : constant Version_32 := 16#f2a06149#;
   pragma Export (C, u00218, "system__response_fileS");

   --  BEGIN ELABORATION ORDER
   --  ada%s
   --  interfaces%s
   --  system%s
   --  system.address_operations%s
   --  system.address_operations%b
   --  system.img_int%s
   --  system.img_int%b
   --  system.parameters%s
   --  system.parameters%b
   --  system.crtl%s
   --  system.storage_elements%s
   --  system.storage_elements%b
   --  system.stack_checking%s
   --  system.stack_checking%b
   --  system.string_hash%s
   --  system.string_hash%b
   --  system.htable%s
   --  system.htable%b
   --  system.strings%s
   --  system.strings%b
   --  system.traceback_entries%s
   --  system.traceback_entries%b
   --  system.unsigned_types%s
   --  system.utf_32%s
   --  system.utf_32%b
   --  system.wch_con%s
   --  system.wch_con%b
   --  system.wch_jis%s
   --  system.wch_jis%b
   --  system.wch_cnv%s
   --  system.wch_cnv%b
   --  system.compare_array_unsigned_8%s
   --  system.compare_array_unsigned_8%b
   --  system.concat_2%s
   --  system.concat_2%b
   --  system.crc32%s
   --  system.crc32%b
   --  system.traceback%s
   --  system.traceback%b
   --  system.secondary_stack%s
   --  system.standard_library%s
   --  ada.exceptions%s
   --  system.exceptions_debug%s
   --  system.exceptions_debug%b
   --  system.soft_links%s
   --  system.wch_stw%s
   --  system.wch_stw%b
   --  ada.exceptions.last_chance_handler%s
   --  ada.exceptions.last_chance_handler%b
   --  ada.exceptions.traceback%s
   --  ada.exceptions.traceback%b
   --  system.address_image%s
   --  system.address_image%b
   --  system.exception_table%s
   --  system.exception_table%b
   --  system.exceptions%s
   --  system.exceptions%b
   --  system.exceptions.machine%s
   --  system.exceptions.machine%b
   --  system.memory%s
   --  system.memory%b
   --  system.secondary_stack%b
   --  system.soft_links.initialize%s
   --  system.soft_links.initialize%b
   --  system.soft_links%b
   --  system.standard_library%b
   --  system.traceback.symbolic%s
   --  system.traceback.symbolic%b
   --  ada.exceptions%b
   --  gnat%s
   --  gnat.heap_sort_a%s
   --  gnat.heap_sort_a%b
   --  gnat.htable%s
   --  gnat.htable%b
   --  system.case_util%s
   --  system.case_util%b
   --  system.os_lib%s
   --  system.os_lib%b
   --  gnat.byte_order_mark%s
   --  gnat.byte_order_mark%b
   --  gnat.dynamic_htables%s
   --  gnat.dynamic_htables%b
   --  gnat.lists%s
   --  gnat.lists%b
   --  gnat.sets%s
   --  gnat.sets%b
   --  gnat.graphs%s
   --  gnat.graphs%b
   --  system.response_file%s
   --  system.response_file%b
   --  debug%s
   --  debug%b
   --  types%s
   --  types%b
   --  alloc%s
   --  gnatvsn%s
   --  gnatvsn%b
   --  hostparm%s
   --  krunch%s
   --  krunch%b
   --  output%s
   --  output%b
   --  rident%s
   --  tree_io%s
   --  tree_io%b
   --  opt%s
   --  opt%b
   --  csets%s
   --  csets%b
   --  stylesw%s
   --  stylesw%b
   --  table%s
   --  table%b
   --  elists%s
   --  elists%b
   --  stand%s
   --  stand%b
   --  uintp%s
   --  uintp%b
   --  urealp%s
   --  urealp%b
   --  widechar%s
   --  widechar%b
   --  namet%s
   --  namet%b
   --  butil%s
   --  butil%b
   --  binderr%s
   --  binderr%b
   --  casing%s
   --  casing%b
   --  err_vars%s
   --  fmap%s
   --  osint%s
   --  fmap%b
   --  sdefault%s
   --  sdefault%b
   --  targparm%s
   --  targparm%b
   --  osint%b
   --  fname%s
   --  fname%b
   --  osint.b%s
   --  osint.b%b
   --  snames%s
   --  snames%b
   --  ali%s
   --  ali%b
   --  binde%s
   --  binde%b
   --  scans%s
   --  scans%b
   --  aspects%s
   --  einfo%s
   --  nlists%s
   --  sinfo%s
   --  atree%s
   --  aspects%b
   --  einfo%b
   --  nlists%b
   --  sinfo%b
   --  sinput%s
   --  sinput%b
   --  atree%b
   --  sem_aux%s
   --  sem_aux%b
   --  sinput.c%s
   --  sinput.c%b
   --  stringt%s
   --  stringt%b
   --  bindgen%s
   --  bindgen%b
   --  erroutc%s
   --  erroutc%b
   --  lib%s
   --  uname%s
   --  uname%b
   --  lib%b
   --  errout%s
   --  errout%b
   --  fname.uf%s
   --  fname.uf%b
   --  restrict%s
   --  restrict%b
   --  bindo%s
   --  bindo.units%s
   --  bindo.graphs%s
   --  bindo.augmentors%s
   --  bindo.builders%s
   --  bindo.diagnostics%s
   --  bindo.elaborators%s
   --  bindo%b
   --  bindo.validators%s
   --  bindo.writers%s
   --  bindo.writers%b
   --  bindo.augmentors%b
   --  bindo.builders%b
   --  bindo.diagnostics%b
   --  bindo.elaborators%b
   --  bindo.graphs%b
   --  bindo.units%b
   --  bindo.validators%b
   --  styleg%s
   --  styleg%b
   --  scng%s
   --  scng%b
   --  ali.util%s
   --  ali.util%b
   --  bcheck%s
   --  bcheck%b
   --  switch%s
   --  switch%b
   --  bindusg%s
   --  bindusg%b
   --  switch.b%s
   --  switch.b%b
   --  gnatbind%s
   --  gnatbind%b
   --  END ELABORATION ORDER

end ada_main;
