pragma Warnings (Off);
pragma Ada_95;
with System;
with System.Parameters;
with System.Secondary_Stack;
package ada_main is

   gnat_argc : Integer;
   gnat_argv : System.Address;
   gnat_envp : System.Address;

   pragma Import (C, gnat_argc);
   pragma Import (C, gnat_argv);
   pragma Import (C, gnat_envp);

   gnat_exit_status : Integer;
   pragma Import (C, gnat_exit_status);

   GNAT_Version : constant String :=
                    "GNAT Version: 10.4.0" & ASCII.NUL;
   pragma Export (C, GNAT_Version, "__gnat_version");

   Ada_Main_Program_Name : constant String := "_ada_gnatlink" & ASCII.NUL;
   pragma Export (C, Ada_Main_Program_Name, "__gnat_ada_main_program_name");

   procedure adainit;
   pragma Export (C, adainit, "adainit");

   procedure adafinal;
   pragma Export (C, adafinal, "adafinal");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer;
   pragma Export (C, main, "main");

   type Version_32 is mod 2 ** 32;
   u00001 : constant Version_32 := 16#3d562fe8#;
   pragma Export (C, u00001, "gnatlinkB");
   u00002 : constant Version_32 := 16#e72e593c#;
   pragma Export (C, u00002, "gnatlinkS");
   u00003 : constant Version_32 := 16#050ff2f0#;
   pragma Export (C, u00003, "system__standard_libraryB");
   u00004 : constant Version_32 := 16#f761c635#;
   pragma Export (C, u00004, "system__standard_libraryS");
   u00005 : constant Version_32 := 16#76789da1#;
   pragma Export (C, u00005, "adaS");
   u00006 : constant Version_32 := 16#f9bb8868#;
   pragma Export (C, u00006, "ada__command_lineB");
   u00007 : constant Version_32 := 16#3cdef8c9#;
   pragma Export (C, u00007, "ada__command_lineS");
   u00008 : constant Version_32 := 16#f047d81a#;
   pragma Export (C, u00008, "systemS");
   u00009 : constant Version_32 := 16#4559752d#;
   pragma Export (C, u00009, "system__secondary_stackB");
   u00010 : constant Version_32 := 16#b5d32003#;
   pragma Export (C, u00010, "system__secondary_stackS");
   u00011 : constant Version_32 := 16#ae2221f9#;
   pragma Export (C, u00011, "ada__exceptionsB");
   u00012 : constant Version_32 := 16#6025bfb5#;
   pragma Export (C, u00012, "ada__exceptionsS");
   u00013 : constant Version_32 := 16#5726abed#;
   pragma Export (C, u00013, "ada__exceptions__last_chance_handlerB");
   u00014 : constant Version_32 := 16#cfec26ee#;
   pragma Export (C, u00014, "ada__exceptions__last_chance_handlerS");
   u00015 : constant Version_32 := 16#ae860117#;
   pragma Export (C, u00015, "system__soft_linksB");
   u00016 : constant Version_32 := 16#3b4da06c#;
   pragma Export (C, u00016, "system__soft_linksS");
   u00017 : constant Version_32 := 16#75bf515c#;
   pragma Export (C, u00017, "system__soft_links__initializeB");
   u00018 : constant Version_32 := 16#5697fc2b#;
   pragma Export (C, u00018, "system__soft_links__initializeS");
   u00019 : constant Version_32 := 16#86dbf443#;
   pragma Export (C, u00019, "system__parametersB");
   u00020 : constant Version_32 := 16#b8ab8c31#;
   pragma Export (C, u00020, "system__parametersS");
   u00021 : constant Version_32 := 16#41837d1e#;
   pragma Export (C, u00021, "system__stack_checkingB");
   u00022 : constant Version_32 := 16#7ef8b3f2#;
   pragma Export (C, u00022, "system__stack_checkingS");
   u00023 : constant Version_32 := 16#ced09590#;
   pragma Export (C, u00023, "system__storage_elementsB");
   u00024 : constant Version_32 := 16#dd84921e#;
   pragma Export (C, u00024, "system__storage_elementsS");
   u00025 : constant Version_32 := 16#34742901#;
   pragma Export (C, u00025, "system__exception_tableB");
   u00026 : constant Version_32 := 16#ade9b158#;
   pragma Export (C, u00026, "system__exception_tableS");
   u00027 : constant Version_32 := 16#ce4af020#;
   pragma Export (C, u00027, "system__exceptionsB");
   u00028 : constant Version_32 := 16#9824b5ec#;
   pragma Export (C, u00028, "system__exceptionsS");
   u00029 : constant Version_32 := 16#69416224#;
   pragma Export (C, u00029, "system__exceptions__machineB");
   u00030 : constant Version_32 := 16#5c74e542#;
   pragma Export (C, u00030, "system__exceptions__machineS");
   u00031 : constant Version_32 := 16#aa0563fc#;
   pragma Export (C, u00031, "system__exceptions_debugB");
   u00032 : constant Version_32 := 16#8ecd21de#;
   pragma Export (C, u00032, "system__exceptions_debugS");
   u00033 : constant Version_32 := 16#6c2f8802#;
   pragma Export (C, u00033, "system__img_intB");
   u00034 : constant Version_32 := 16#f29c38d8#;
   pragma Export (C, u00034, "system__img_intS");
   u00035 : constant Version_32 := 16#39df8c17#;
   pragma Export (C, u00035, "system__tracebackB");
   u00036 : constant Version_32 := 16#ae6506de#;
   pragma Export (C, u00036, "system__tracebackS");
   u00037 : constant Version_32 := 16#9ed49525#;
   pragma Export (C, u00037, "system__traceback_entriesB");
   u00038 : constant Version_32 := 16#f01c2e6a#;
   pragma Export (C, u00038, "system__traceback_entriesS");
   u00039 : constant Version_32 := 16#448e9548#;
   pragma Export (C, u00039, "system__traceback__symbolicB");
   u00040 : constant Version_32 := 16#46491211#;
   pragma Export (C, u00040, "system__traceback__symbolicS");
   u00041 : constant Version_32 := 16#179d7d28#;
   pragma Export (C, u00041, "ada__containersS");
   u00042 : constant Version_32 := 16#701f9d88#;
   pragma Export (C, u00042, "ada__exceptions__tracebackB");
   u00043 : constant Version_32 := 16#ae2d2db5#;
   pragma Export (C, u00043, "ada__exceptions__tracebackS");
   u00044 : constant Version_32 := 16#5ab55268#;
   pragma Export (C, u00044, "interfacesS");
   u00045 : constant Version_32 := 16#769e25e6#;
   pragma Export (C, u00045, "interfaces__cB");
   u00046 : constant Version_32 := 16#467817d8#;
   pragma Export (C, u00046, "interfaces__cS");
   u00047 : constant Version_32 := 16#e865e681#;
   pragma Export (C, u00047, "system__bounded_stringsB");
   u00048 : constant Version_32 := 16#87baf903#;
   pragma Export (C, u00048, "system__bounded_stringsS");
   u00049 : constant Version_32 := 16#b6105740#;
   pragma Export (C, u00049, "system__crtlS");
   u00050 : constant Version_32 := 16#0dd5afd5#;
   pragma Export (C, u00050, "system__dwarf_linesB");
   u00051 : constant Version_32 := 16#2c0ae59f#;
   pragma Export (C, u00051, "system__dwarf_linesS");
   u00052 : constant Version_32 := 16#5b4659fa#;
   pragma Export (C, u00052, "ada__charactersS");
   u00053 : constant Version_32 := 16#8f637df8#;
   pragma Export (C, u00053, "ada__characters__handlingB");
   u00054 : constant Version_32 := 16#3b3f6154#;
   pragma Export (C, u00054, "ada__characters__handlingS");
   u00055 : constant Version_32 := 16#4b7bb96a#;
   pragma Export (C, u00055, "ada__characters__latin_1S");
   u00056 : constant Version_32 := 16#e6d4fa36#;
   pragma Export (C, u00056, "ada__stringsS");
   u00057 : constant Version_32 := 16#96df1a3f#;
   pragma Export (C, u00057, "ada__strings__mapsB");
   u00058 : constant Version_32 := 16#1e526bec#;
   pragma Export (C, u00058, "ada__strings__mapsS");
   u00059 : constant Version_32 := 16#eef4ff2f#;
   pragma Export (C, u00059, "system__bit_opsB");
   u00060 : constant Version_32 := 16#0765e3a3#;
   pragma Export (C, u00060, "system__bit_opsS");
   u00061 : constant Version_32 := 16#c4c1a499#;
   pragma Export (C, u00061, "system__unsigned_typesS");
   u00062 : constant Version_32 := 16#92f05f13#;
   pragma Export (C, u00062, "ada__strings__maps__constantsS");
   u00063 : constant Version_32 := 16#a0d3d22b#;
   pragma Export (C, u00063, "system__address_imageB");
   u00064 : constant Version_32 := 16#51ab4520#;
   pragma Export (C, u00064, "system__address_imageS");
   u00065 : constant Version_32 := 16#ec78c2bf#;
   pragma Export (C, u00065, "system__img_unsB");
   u00066 : constant Version_32 := 16#5b35986e#;
   pragma Export (C, u00066, "system__img_unsS");
   u00067 : constant Version_32 := 16#d7aac20c#;
   pragma Export (C, u00067, "system__ioB");
   u00068 : constant Version_32 := 16#6e052f55#;
   pragma Export (C, u00068, "system__ioS");
   u00069 : constant Version_32 := 16#f790d1ef#;
   pragma Export (C, u00069, "system__mmapB");
   u00070 : constant Version_32 := 16#ca36677d#;
   pragma Export (C, u00070, "system__mmapS");
   u00071 : constant Version_32 := 16#92d882c5#;
   pragma Export (C, u00071, "ada__io_exceptionsS");
   u00072 : constant Version_32 := 16#2798fe30#;
   pragma Export (C, u00072, "system__mmap__os_interfaceB");
   u00073 : constant Version_32 := 16#1fc2f713#;
   pragma Export (C, u00073, "system__mmap__os_interfaceS");
   u00074 : constant Version_32 := 16#1e7d913a#;
   pragma Export (C, u00074, "system__mmap__unixS");
   u00075 : constant Version_32 := 16#e2303f7e#;
   pragma Export (C, u00075, "system__os_libB");
   u00076 : constant Version_32 := 16#d872da39#;
   pragma Export (C, u00076, "system__os_libS");
   u00077 : constant Version_32 := 16#ec4d5631#;
   pragma Export (C, u00077, "system__case_utilB");
   u00078 : constant Version_32 := 16#cf926e4e#;
   pragma Export (C, u00078, "system__case_utilS");
   u00079 : constant Version_32 := 16#2a8e89ad#;
   pragma Export (C, u00079, "system__stringsB");
   u00080 : constant Version_32 := 16#9051f48f#;
   pragma Export (C, u00080, "system__stringsS");
   u00081 : constant Version_32 := 16#5a3f5337#;
   pragma Export (C, u00081, "system__object_readerB");
   u00082 : constant Version_32 := 16#3433051b#;
   pragma Export (C, u00082, "system__object_readerS");
   u00083 : constant Version_32 := 16#fb020d94#;
   pragma Export (C, u00083, "system__val_lliB");
   u00084 : constant Version_32 := 16#9c294aea#;
   pragma Export (C, u00084, "system__val_lliS");
   u00085 : constant Version_32 := 16#b8e72903#;
   pragma Export (C, u00085, "system__val_lluB");
   u00086 : constant Version_32 := 16#a90f297b#;
   pragma Export (C, u00086, "system__val_lluS");
   u00087 : constant Version_32 := 16#269742a9#;
   pragma Export (C, u00087, "system__val_utilB");
   u00088 : constant Version_32 := 16#5ce76ee4#;
   pragma Export (C, u00088, "system__val_utilS");
   u00089 : constant Version_32 := 16#d7bf3f29#;
   pragma Export (C, u00089, "system__exception_tracesB");
   u00090 : constant Version_32 := 16#d498f880#;
   pragma Export (C, u00090, "system__exception_tracesS");
   u00091 : constant Version_32 := 16#8c33a517#;
   pragma Export (C, u00091, "system__wch_conB");
   u00092 : constant Version_32 := 16#eb3afac8#;
   pragma Export (C, u00092, "system__wch_conS");
   u00093 : constant Version_32 := 16#9721e840#;
   pragma Export (C, u00093, "system__wch_stwB");
   u00094 : constant Version_32 := 16#c62bd6c9#;
   pragma Export (C, u00094, "system__wch_stwS");
   u00095 : constant Version_32 := 16#a831679c#;
   pragma Export (C, u00095, "system__wch_cnvB");
   u00096 : constant Version_32 := 16#e48d403b#;
   pragma Export (C, u00096, "system__wch_cnvS");
   u00097 : constant Version_32 := 16#ece6fdb6#;
   pragma Export (C, u00097, "system__wch_jisB");
   u00098 : constant Version_32 := 16#64fd591a#;
   pragma Export (C, u00098, "system__wch_jisS");
   u00099 : constant Version_32 := 16#abfcab7d#;
   pragma Export (C, u00099, "aliB");
   u00100 : constant Version_32 := 16#4f5456e6#;
   pragma Export (C, u00100, "aliS");
   u00101 : constant Version_32 := 16#c017f602#;
   pragma Export (C, u00101, "butilB");
   u00102 : constant Version_32 := 16#0d752381#;
   pragma Export (C, u00102, "butilS");
   u00103 : constant Version_32 := 16#b5988c27#;
   pragma Export (C, u00103, "gnatS");
   u00104 : constant Version_32 := 16#3299b26a#;
   pragma Export (C, u00104, "optB");
   u00105 : constant Version_32 := 16#5897096d#;
   pragma Export (C, u00105, "optS");
   u00106 : constant Version_32 := 16#5d525d24#;
   pragma Export (C, u00106, "gnatvsnB");
   u00107 : constant Version_32 := 16#aed2d083#;
   pragma Export (C, u00107, "gnatvsnS");
   u00108 : constant Version_32 := 16#dcf8e2cf#;
   pragma Export (C, u00108, "system__assertionsB");
   u00109 : constant Version_32 := 16#3dcaf48e#;
   pragma Export (C, u00109, "system__assertionsS");
   u00110 : constant Version_32 := 16#b9a3a899#;
   pragma Export (C, u00110, "tree_ioB");
   u00111 : constant Version_32 := 16#15844d9c#;
   pragma Export (C, u00111, "tree_ioS");
   u00112 : constant Version_32 := 16#91fc5baa#;
   pragma Export (C, u00112, "debugB");
   u00113 : constant Version_32 := 16#1ac546f9#;
   pragma Export (C, u00113, "debugS");
   u00114 : constant Version_32 := 16#39794d05#;
   pragma Export (C, u00114, "outputB");
   u00115 : constant Version_32 := 16#83393876#;
   pragma Export (C, u00115, "outputS");
   u00116 : constant Version_32 := 16#7db849eb#;
   pragma Export (C, u00116, "hostparmS");
   u00117 : constant Version_32 := 16#fd83e873#;
   pragma Export (C, u00117, "system__concat_2B");
   u00118 : constant Version_32 := 16#f2e70fca#;
   pragma Export (C, u00118, "system__concat_2S");
   u00119 : constant Version_32 := 16#587eb9ab#;
   pragma Export (C, u00119, "typesB");
   u00120 : constant Version_32 := 16#c499bf82#;
   pragma Export (C, u00120, "typesS");
   u00121 : constant Version_32 := 16#acee74ad#;
   pragma Export (C, u00121, "system__compare_array_unsigned_8B");
   u00122 : constant Version_32 := 16#5944a997#;
   pragma Export (C, u00122, "system__compare_array_unsigned_8S");
   u00123 : constant Version_32 := 16#a8025f3c#;
   pragma Export (C, u00123, "system__address_operationsB");
   u00124 : constant Version_32 := 16#e34b6629#;
   pragma Export (C, u00124, "system__address_operationsS");
   u00125 : constant Version_32 := 16#bbff9f5c#;
   pragma Export (C, u00125, "nametB");
   u00126 : constant Version_32 := 16#f1c61094#;
   pragma Export (C, u00126, "nametS");
   u00127 : constant Version_32 := 16#700bac7f#;
   pragma Export (C, u00127, "widecharB");
   u00128 : constant Version_32 := 16#700d44f3#;
   pragma Export (C, u00128, "widecharS");
   u00129 : constant Version_32 := 16#972e59bd#;
   pragma Export (C, u00129, "allocS");
   u00130 : constant Version_32 := 16#413de238#;
   pragma Export (C, u00130, "tableB");
   u00131 : constant Version_32 := 16#71c45158#;
   pragma Export (C, u00131, "tableS");
   u00132 : constant Version_32 := 16#e31b7c4e#;
   pragma Export (C, u00132, "system__memoryB");
   u00133 : constant Version_32 := 16#a93abe2e#;
   pragma Export (C, u00133, "system__memoryS");
   u00134 : constant Version_32 := 16#e909d55e#;
   pragma Export (C, u00134, "fnameB");
   u00135 : constant Version_32 := 16#06dc2a66#;
   pragma Export (C, u00135, "fnameS");
   u00136 : constant Version_32 := 16#2044a70d#;
   pragma Export (C, u00136, "gnat__dynamic_htablesB");
   u00137 : constant Version_32 := 16#05f952b6#;
   pragma Export (C, u00137, "gnat__dynamic_htablesS");
   u00138 : constant Version_32 := 16#17fb561a#;
   pragma Export (C, u00138, "osintB");
   u00139 : constant Version_32 := 16#e640ad21#;
   pragma Export (C, u00139, "osintS");
   u00140 : constant Version_32 := 16#c4507fa7#;
   pragma Export (C, u00140, "fmapB");
   u00141 : constant Version_32 := 16#9ac5a2f6#;
   pragma Export (C, u00141, "fmapS");
   u00142 : constant Version_32 := 16#be789e08#;
   pragma Export (C, u00142, "gnat__htableB");
   u00143 : constant Version_32 := 16#7a3e0440#;
   pragma Export (C, u00143, "gnat__htableS");
   u00144 : constant Version_32 := 16#796f31f1#;
   pragma Export (C, u00144, "system__htableB");
   u00145 : constant Version_32 := 16#74856bf0#;
   pragma Export (C, u00145, "system__htableS");
   u00146 : constant Version_32 := 16#089f5cd0#;
   pragma Export (C, u00146, "system__string_hashB");
   u00147 : constant Version_32 := 16#d6db008e#;
   pragma Export (C, u00147, "system__string_hashS");
   u00148 : constant Version_32 := 16#b910cc1d#;
   pragma Export (C, u00148, "sdefaultB");
   u00149 : constant Version_32 := 16#a7d7201f#;
   pragma Export (C, u00149, "sdefaultS");
   u00150 : constant Version_32 := 16#40dce533#;
   pragma Export (C, u00150, "targparmB");
   u00151 : constant Version_32 := 16#24210956#;
   pragma Export (C, u00151, "targparmS");
   u00152 : constant Version_32 := 16#46a3369a#;
   pragma Export (C, u00152, "csetsB");
   u00153 : constant Version_32 := 16#e948558f#;
   pragma Export (C, u00153, "csetsS");
   u00154 : constant Version_32 := 16#27e30df3#;
   pragma Export (C, u00154, "ridentS");
   u00155 : constant Version_32 := 16#a19d6876#;
   pragma Export (C, u00155, "snamesB");
   u00156 : constant Version_32 := 16#2b47cd92#;
   pragma Export (C, u00156, "snamesS");
   u00157 : constant Version_32 := 16#cfbc3039#;
   pragma Export (C, u00157, "casingB");
   u00158 : constant Version_32 := 16#f1067a43#;
   pragma Export (C, u00158, "casingS");
   u00159 : constant Version_32 := 16#0a85a591#;
   pragma Export (C, u00159, "indepswB");
   u00160 : constant Version_32 := 16#e3de4372#;
   pragma Export (C, u00160, "indepswS");
   u00161 : constant Version_32 := 16#df84da75#;
   pragma Export (C, u00161, "interfaces__c__stringsB");
   u00162 : constant Version_32 := 16#603c1c44#;
   pragma Export (C, u00162, "interfaces__c__stringsS");
   u00163 : constant Version_32 := 16#73d2d764#;
   pragma Export (C, u00163, "interfaces__c_streamsB");
   u00164 : constant Version_32 := 16#b1330297#;
   pragma Export (C, u00164, "interfaces__c_streamsS");
   u00165 : constant Version_32 := 16#a88c6d24#;
   pragma Export (C, u00165, "switchB");
   u00166 : constant Version_32 := 16#cb06ad41#;
   pragma Export (C, u00166, "switchS");

   --  BEGIN ELABORATION ORDER
   --  ada%s
   --  ada.characters%s
   --  ada.characters.latin_1%s
   --  interfaces%s
   --  system%s
   --  system.address_operations%s
   --  system.address_operations%b
   --  system.img_int%s
   --  system.img_int%b
   --  system.io%s
   --  system.io%b
   --  system.parameters%s
   --  system.parameters%b
   --  system.crtl%s
   --  interfaces.c_streams%s
   --  interfaces.c_streams%b
   --  system.storage_elements%s
   --  system.storage_elements%b
   --  system.stack_checking%s
   --  system.stack_checking%b
   --  system.string_hash%s
   --  system.string_hash%b
   --  system.htable%s
   --  system.htable%b
   --  system.strings%s
   --  system.strings%b
   --  system.traceback_entries%s
   --  system.traceback_entries%b
   --  system.unsigned_types%s
   --  system.img_uns%s
   --  system.img_uns%b
   --  system.wch_con%s
   --  system.wch_con%b
   --  system.wch_jis%s
   --  system.wch_jis%b
   --  system.wch_cnv%s
   --  system.wch_cnv%b
   --  system.compare_array_unsigned_8%s
   --  system.compare_array_unsigned_8%b
   --  system.concat_2%s
   --  system.concat_2%b
   --  system.traceback%s
   --  system.traceback%b
   --  ada.characters.handling%s
   --  system.case_util%s
   --  system.os_lib%s
   --  system.secondary_stack%s
   --  system.standard_library%s
   --  ada.exceptions%s
   --  system.exceptions_debug%s
   --  system.exceptions_debug%b
   --  system.soft_links%s
   --  system.val_lli%s
   --  system.val_llu%s
   --  system.val_util%s
   --  system.val_util%b
   --  system.wch_stw%s
   --  system.wch_stw%b
   --  ada.exceptions.last_chance_handler%s
   --  ada.exceptions.last_chance_handler%b
   --  ada.exceptions.traceback%s
   --  ada.exceptions.traceback%b
   --  system.address_image%s
   --  system.address_image%b
   --  system.bit_ops%s
   --  system.bit_ops%b
   --  system.bounded_strings%s
   --  system.bounded_strings%b
   --  system.case_util%b
   --  system.exception_table%s
   --  system.exception_table%b
   --  ada.containers%s
   --  ada.io_exceptions%s
   --  ada.strings%s
   --  ada.strings.maps%s
   --  ada.strings.maps%b
   --  ada.strings.maps.constants%s
   --  interfaces.c%s
   --  interfaces.c%b
   --  system.exceptions%s
   --  system.exceptions%b
   --  system.exceptions.machine%s
   --  system.exceptions.machine%b
   --  ada.characters.handling%b
   --  system.exception_traces%s
   --  system.exception_traces%b
   --  system.memory%s
   --  system.memory%b
   --  system.mmap%s
   --  system.mmap.os_interface%s
   --  system.mmap%b
   --  system.mmap.unix%s
   --  system.mmap.os_interface%b
   --  system.object_reader%s
   --  system.object_reader%b
   --  system.dwarf_lines%s
   --  system.dwarf_lines%b
   --  system.os_lib%b
   --  system.secondary_stack%b
   --  system.soft_links.initialize%s
   --  system.soft_links.initialize%b
   --  system.soft_links%b
   --  system.standard_library%b
   --  system.traceback.symbolic%s
   --  system.traceback.symbolic%b
   --  ada.exceptions%b
   --  system.val_lli%b
   --  system.val_llu%b
   --  ada.command_line%s
   --  ada.command_line%b
   --  gnat%s
   --  gnat.htable%s
   --  gnat.htable%b
   --  interfaces.c.strings%s
   --  interfaces.c.strings%b
   --  gnat.dynamic_htables%s
   --  gnat.dynamic_htables%b
   --  system.assertions%s
   --  system.assertions%b
   --  debug%s
   --  debug%b
   --  types%s
   --  types%b
   --  alloc%s
   --  gnatvsn%s
   --  gnatvsn%b
   --  hostparm%s
   --  indepsw%s
   --  indepsw%b
   --  output%s
   --  output%b
   --  rident%s
   --  tree_io%s
   --  tree_io%b
   --  opt%s
   --  opt%b
   --  csets%s
   --  csets%b
   --  table%s
   --  table%b
   --  widechar%s
   --  widechar%b
   --  namet%s
   --  namet%b
   --  butil%s
   --  butil%b
   --  casing%s
   --  casing%b
   --  fmap%s
   --  osint%s
   --  fmap%b
   --  sdefault%s
   --  sdefault%b
   --  targparm%s
   --  targparm%b
   --  osint%b
   --  fname%s
   --  fname%b
   --  snames%s
   --  snames%b
   --  ali%s
   --  ali%b
   --  switch%s
   --  switch%b
   --  gnatlink%s
   --  gnatlink%b
   --  END ELABORATION ORDER

end ada_main;
