pragma Warnings (Off);
pragma Ada_95;
with System;
with System.Parameters;
with System.Secondary_Stack;
package ada_main is

   gnat_argc : Integer;
   gnat_argv : System.Address;
   gnat_envp : System.Address;

   pragma Import (C, gnat_argc);
   pragma Import (C, gnat_argv);
   pragma Import (C, gnat_envp);

   gnat_exit_status : Integer;
   pragma Import (C, gnat_exit_status);

   GNAT_Version : constant String :=
                    "GNAT Version: 10.4.0" & ASCII.NUL;
   pragma Export (C, GNAT_Version, "__gnat_version");

   Ada_Main_Program_Name : constant String := "_ada_gnatmake" & ASCII.NUL;
   pragma Export (C, Ada_Main_Program_Name, "__gnat_ada_main_program_name");

   procedure adainit;
   pragma Export (C, adainit, "adainit");

   procedure adafinal;
   pragma Export (C, adafinal, "adafinal");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer;
   pragma Export (C, main, "main");

   type Version_32 is mod 2 ** 32;
   u00001 : constant Version_32 := 16#354cfb01#;
   pragma Export (C, u00001, "gnatmakeB");
   u00002 : constant Version_32 := 16#2f7236c5#;
   pragma Export (C, u00002, "gnatmakeS");
   u00003 : constant Version_32 := 16#050ff2f0#;
   pragma Export (C, u00003, "system__standard_libraryB");
   u00004 : constant Version_32 := 16#f761c635#;
   pragma Export (C, u00004, "system__standard_libraryS");
   u00005 : constant Version_32 := 16#5d525d24#;
   pragma Export (C, u00005, "gnatvsnB");
   u00006 : constant Version_32 := 16#aed2d083#;
   pragma Export (C, u00006, "gnatvsnS");
   u00007 : constant Version_32 := 16#4559752d#;
   pragma Export (C, u00007, "system__secondary_stackB");
   u00008 : constant Version_32 := 16#b5d32003#;
   pragma Export (C, u00008, "system__secondary_stackS");
   u00009 : constant Version_32 := 16#76789da1#;
   pragma Export (C, u00009, "adaS");
   u00010 : constant Version_32 := 16#ae2221f9#;
   pragma Export (C, u00010, "ada__exceptionsB");
   u00011 : constant Version_32 := 16#6025bfb5#;
   pragma Export (C, u00011, "ada__exceptionsS");
   u00012 : constant Version_32 := 16#5726abed#;
   pragma Export (C, u00012, "ada__exceptions__last_chance_handlerB");
   u00013 : constant Version_32 := 16#cfec26ee#;
   pragma Export (C, u00013, "ada__exceptions__last_chance_handlerS");
   u00014 : constant Version_32 := 16#f047d81a#;
   pragma Export (C, u00014, "systemS");
   u00015 : constant Version_32 := 16#ae860117#;
   pragma Export (C, u00015, "system__soft_linksB");
   u00016 : constant Version_32 := 16#3b4da06c#;
   pragma Export (C, u00016, "system__soft_linksS");
   u00017 : constant Version_32 := 16#75bf515c#;
   pragma Export (C, u00017, "system__soft_links__initializeB");
   u00018 : constant Version_32 := 16#5697fc2b#;
   pragma Export (C, u00018, "system__soft_links__initializeS");
   u00019 : constant Version_32 := 16#86dbf443#;
   pragma Export (C, u00019, "system__parametersB");
   u00020 : constant Version_32 := 16#b8ab8c31#;
   pragma Export (C, u00020, "system__parametersS");
   u00021 : constant Version_32 := 16#41837d1e#;
   pragma Export (C, u00021, "system__stack_checkingB");
   u00022 : constant Version_32 := 16#7ef8b3f2#;
   pragma Export (C, u00022, "system__stack_checkingS");
   u00023 : constant Version_32 := 16#ced09590#;
   pragma Export (C, u00023, "system__storage_elementsB");
   u00024 : constant Version_32 := 16#dd84921e#;
   pragma Export (C, u00024, "system__storage_elementsS");
   u00025 : constant Version_32 := 16#34742901#;
   pragma Export (C, u00025, "system__exception_tableB");
   u00026 : constant Version_32 := 16#ade9b158#;
   pragma Export (C, u00026, "system__exception_tableS");
   u00027 : constant Version_32 := 16#ce4af020#;
   pragma Export (C, u00027, "system__exceptionsB");
   u00028 : constant Version_32 := 16#9824b5ec#;
   pragma Export (C, u00028, "system__exceptionsS");
   u00029 : constant Version_32 := 16#69416224#;
   pragma Export (C, u00029, "system__exceptions__machineB");
   u00030 : constant Version_32 := 16#5c74e542#;
   pragma Export (C, u00030, "system__exceptions__machineS");
   u00031 : constant Version_32 := 16#aa0563fc#;
   pragma Export (C, u00031, "system__exceptions_debugB");
   u00032 : constant Version_32 := 16#8ecd21de#;
   pragma Export (C, u00032, "system__exceptions_debugS");
   u00033 : constant Version_32 := 16#6c2f8802#;
   pragma Export (C, u00033, "system__img_intB");
   u00034 : constant Version_32 := 16#f29c38d8#;
   pragma Export (C, u00034, "system__img_intS");
   u00035 : constant Version_32 := 16#39df8c17#;
   pragma Export (C, u00035, "system__tracebackB");
   u00036 : constant Version_32 := 16#ae6506de#;
   pragma Export (C, u00036, "system__tracebackS");
   u00037 : constant Version_32 := 16#9ed49525#;
   pragma Export (C, u00037, "system__traceback_entriesB");
   u00038 : constant Version_32 := 16#f01c2e6a#;
   pragma Export (C, u00038, "system__traceback_entriesS");
   u00039 : constant Version_32 := 16#448e9548#;
   pragma Export (C, u00039, "system__traceback__symbolicB");
   u00040 : constant Version_32 := 16#46491211#;
   pragma Export (C, u00040, "system__traceback__symbolicS");
   u00041 : constant Version_32 := 16#179d7d28#;
   pragma Export (C, u00041, "ada__containersS");
   u00042 : constant Version_32 := 16#701f9d88#;
   pragma Export (C, u00042, "ada__exceptions__tracebackB");
   u00043 : constant Version_32 := 16#ae2d2db5#;
   pragma Export (C, u00043, "ada__exceptions__tracebackS");
   u00044 : constant Version_32 := 16#5ab55268#;
   pragma Export (C, u00044, "interfacesS");
   u00045 : constant Version_32 := 16#769e25e6#;
   pragma Export (C, u00045, "interfaces__cB");
   u00046 : constant Version_32 := 16#467817d8#;
   pragma Export (C, u00046, "interfaces__cS");
   u00047 : constant Version_32 := 16#e865e681#;
   pragma Export (C, u00047, "system__bounded_stringsB");
   u00048 : constant Version_32 := 16#87baf903#;
   pragma Export (C, u00048, "system__bounded_stringsS");
   u00049 : constant Version_32 := 16#b6105740#;
   pragma Export (C, u00049, "system__crtlS");
   u00050 : constant Version_32 := 16#0dd5afd5#;
   pragma Export (C, u00050, "system__dwarf_linesB");
   u00051 : constant Version_32 := 16#2c0ae59f#;
   pragma Export (C, u00051, "system__dwarf_linesS");
   u00052 : constant Version_32 := 16#5b4659fa#;
   pragma Export (C, u00052, "ada__charactersS");
   u00053 : constant Version_32 := 16#8f637df8#;
   pragma Export (C, u00053, "ada__characters__handlingB");
   u00054 : constant Version_32 := 16#3b3f6154#;
   pragma Export (C, u00054, "ada__characters__handlingS");
   u00055 : constant Version_32 := 16#4b7bb96a#;
   pragma Export (C, u00055, "ada__characters__latin_1S");
   u00056 : constant Version_32 := 16#e6d4fa36#;
   pragma Export (C, u00056, "ada__stringsS");
   u00057 : constant Version_32 := 16#96df1a3f#;
   pragma Export (C, u00057, "ada__strings__mapsB");
   u00058 : constant Version_32 := 16#1e526bec#;
   pragma Export (C, u00058, "ada__strings__mapsS");
   u00059 : constant Version_32 := 16#eef4ff2f#;
   pragma Export (C, u00059, "system__bit_opsB");
   u00060 : constant Version_32 := 16#0765e3a3#;
   pragma Export (C, u00060, "system__bit_opsS");
   u00061 : constant Version_32 := 16#c4c1a499#;
   pragma Export (C, u00061, "system__unsigned_typesS");
   u00062 : constant Version_32 := 16#92f05f13#;
   pragma Export (C, u00062, "ada__strings__maps__constantsS");
   u00063 : constant Version_32 := 16#a0d3d22b#;
   pragma Export (C, u00063, "system__address_imageB");
   u00064 : constant Version_32 := 16#51ab4520#;
   pragma Export (C, u00064, "system__address_imageS");
   u00065 : constant Version_32 := 16#ec78c2bf#;
   pragma Export (C, u00065, "system__img_unsB");
   u00066 : constant Version_32 := 16#5b35986e#;
   pragma Export (C, u00066, "system__img_unsS");
   u00067 : constant Version_32 := 16#d7aac20c#;
   pragma Export (C, u00067, "system__ioB");
   u00068 : constant Version_32 := 16#6e052f55#;
   pragma Export (C, u00068, "system__ioS");
   u00069 : constant Version_32 := 16#f790d1ef#;
   pragma Export (C, u00069, "system__mmapB");
   u00070 : constant Version_32 := 16#ca36677d#;
   pragma Export (C, u00070, "system__mmapS");
   u00071 : constant Version_32 := 16#92d882c5#;
   pragma Export (C, u00071, "ada__io_exceptionsS");
   u00072 : constant Version_32 := 16#2798fe30#;
   pragma Export (C, u00072, "system__mmap__os_interfaceB");
   u00073 : constant Version_32 := 16#1fc2f713#;
   pragma Export (C, u00073, "system__mmap__os_interfaceS");
   u00074 : constant Version_32 := 16#1e7d913a#;
   pragma Export (C, u00074, "system__mmap__unixS");
   u00075 : constant Version_32 := 16#e2303f7e#;
   pragma Export (C, u00075, "system__os_libB");
   u00076 : constant Version_32 := 16#d872da39#;
   pragma Export (C, u00076, "system__os_libS");
   u00077 : constant Version_32 := 16#ec4d5631#;
   pragma Export (C, u00077, "system__case_utilB");
   u00078 : constant Version_32 := 16#cf926e4e#;
   pragma Export (C, u00078, "system__case_utilS");
   u00079 : constant Version_32 := 16#2a8e89ad#;
   pragma Export (C, u00079, "system__stringsB");
   u00080 : constant Version_32 := 16#9051f48f#;
   pragma Export (C, u00080, "system__stringsS");
   u00081 : constant Version_32 := 16#5a3f5337#;
   pragma Export (C, u00081, "system__object_readerB");
   u00082 : constant Version_32 := 16#3433051b#;
   pragma Export (C, u00082, "system__object_readerS");
   u00083 : constant Version_32 := 16#fb020d94#;
   pragma Export (C, u00083, "system__val_lliB");
   u00084 : constant Version_32 := 16#9c294aea#;
   pragma Export (C, u00084, "system__val_lliS");
   u00085 : constant Version_32 := 16#b8e72903#;
   pragma Export (C, u00085, "system__val_lluB");
   u00086 : constant Version_32 := 16#a90f297b#;
   pragma Export (C, u00086, "system__val_lluS");
   u00087 : constant Version_32 := 16#269742a9#;
   pragma Export (C, u00087, "system__val_utilB");
   u00088 : constant Version_32 := 16#5ce76ee4#;
   pragma Export (C, u00088, "system__val_utilS");
   u00089 : constant Version_32 := 16#d7bf3f29#;
   pragma Export (C, u00089, "system__exception_tracesB");
   u00090 : constant Version_32 := 16#d498f880#;
   pragma Export (C, u00090, "system__exception_tracesS");
   u00091 : constant Version_32 := 16#8c33a517#;
   pragma Export (C, u00091, "system__wch_conB");
   u00092 : constant Version_32 := 16#eb3afac8#;
   pragma Export (C, u00092, "system__wch_conS");
   u00093 : constant Version_32 := 16#9721e840#;
   pragma Export (C, u00093, "system__wch_stwB");
   u00094 : constant Version_32 := 16#c62bd6c9#;
   pragma Export (C, u00094, "system__wch_stwS");
   u00095 : constant Version_32 := 16#a831679c#;
   pragma Export (C, u00095, "system__wch_cnvB");
   u00096 : constant Version_32 := 16#e48d403b#;
   pragma Export (C, u00096, "system__wch_cnvS");
   u00097 : constant Version_32 := 16#ece6fdb6#;
   pragma Export (C, u00097, "system__wch_jisB");
   u00098 : constant Version_32 := 16#64fd591a#;
   pragma Export (C, u00098, "system__wch_jisS");
   u00099 : constant Version_32 := 16#db93d0bc#;
   pragma Export (C, u00099, "makeB");
   u00100 : constant Version_32 := 16#f8ac97ed#;
   pragma Export (C, u00100, "makeS");
   u00101 : constant Version_32 := 16#f9bb8868#;
   pragma Export (C, u00101, "ada__command_lineB");
   u00102 : constant Version_32 := 16#3cdef8c9#;
   pragma Export (C, u00102, "ada__command_lineS");
   u00103 : constant Version_32 := 16#24205536#;
   pragma Export (C, u00103, "ada__directoriesB");
   u00104 : constant Version_32 := 16#7b0ecd0f#;
   pragma Export (C, u00104, "ada__directoriesS");
   u00105 : constant Version_32 := 16#fc54e290#;
   pragma Export (C, u00105, "ada__calendarB");
   u00106 : constant Version_32 := 16#31350a81#;
   pragma Export (C, u00106, "ada__calendarS");
   u00107 : constant Version_32 := 16#51f2d040#;
   pragma Export (C, u00107, "system__os_primitivesB");
   u00108 : constant Version_32 := 16#f7babdec#;
   pragma Export (C, u00108, "system__os_primitivesS");
   u00109 : constant Version_32 := 16#26518ca7#;
   pragma Export (C, u00109, "ada__calendar__formattingB");
   u00110 : constant Version_32 := 16#0dbf7387#;
   pragma Export (C, u00110, "ada__calendar__formattingS");
   u00111 : constant Version_32 := 16#e3cca715#;
   pragma Export (C, u00111, "ada__calendar__time_zonesB");
   u00112 : constant Version_32 := 16#07d0e97b#;
   pragma Export (C, u00112, "ada__calendar__time_zonesS");
   u00113 : constant Version_32 := 16#0f9783a4#;
   pragma Export (C, u00113, "system__val_intB");
   u00114 : constant Version_32 := 16#45b8b179#;
   pragma Export (C, u00114, "system__val_intS");
   u00115 : constant Version_32 := 16#383fd226#;
   pragma Export (C, u00115, "system__val_unsB");
   u00116 : constant Version_32 := 16#f1c7d920#;
   pragma Export (C, u00116, "system__val_unsS");
   u00117 : constant Version_32 := 16#6620fa49#;
   pragma Export (C, u00117, "system__val_realB");
   u00118 : constant Version_32 := 16#fe3834cf#;
   pragma Export (C, u00118, "system__val_realS");
   u00119 : constant Version_32 := 16#b2a569d2#;
   pragma Export (C, u00119, "system__exn_llfB");
   u00120 : constant Version_32 := 16#4c3963c6#;
   pragma Export (C, u00120, "system__exn_llfS");
   u00121 : constant Version_32 := 16#1b28662b#;
   pragma Export (C, u00121, "system__float_controlB");
   u00122 : constant Version_32 := 16#10bb9b26#;
   pragma Export (C, u00122, "system__float_controlS");
   u00123 : constant Version_32 := 16#2f92a3a3#;
   pragma Export (C, u00123, "ada__directories__hierarchical_file_namesB");
   u00124 : constant Version_32 := 16#752941c9#;
   pragma Export (C, u00124, "ada__directories__hierarchical_file_namesS");
   u00125 : constant Version_32 := 16#ab4ad33a#;
   pragma Export (C, u00125, "ada__directories__validityB");
   u00126 : constant Version_32 := 16#498b13d5#;
   pragma Export (C, u00126, "ada__directories__validityS");
   u00127 : constant Version_32 := 16#bf363ed2#;
   pragma Export (C, u00127, "ada__strings__fixedB");
   u00128 : constant Version_32 := 16#fec1aafc#;
   pragma Export (C, u00128, "ada__strings__fixedS");
   u00129 : constant Version_32 := 16#d6a83d8c#;
   pragma Export (C, u00129, "ada__strings__searchB");
   u00130 : constant Version_32 := 16#c1ab8667#;
   pragma Export (C, u00130, "ada__strings__searchS");
   u00131 : constant Version_32 := 16#5d91da9f#;
   pragma Export (C, u00131, "ada__tagsB");
   u00132 : constant Version_32 := 16#12a0afb8#;
   pragma Export (C, u00132, "ada__tagsS");
   u00133 : constant Version_32 := 16#796f31f1#;
   pragma Export (C, u00133, "system__htableB");
   u00134 : constant Version_32 := 16#74856bf0#;
   pragma Export (C, u00134, "system__htableS");
   u00135 : constant Version_32 := 16#089f5cd0#;
   pragma Export (C, u00135, "system__string_hashB");
   u00136 : constant Version_32 := 16#d6db008e#;
   pragma Export (C, u00136, "system__string_hashS");
   u00137 : constant Version_32 := 16#351539c5#;
   pragma Export (C, u00137, "ada__strings__unboundedB");
   u00138 : constant Version_32 := 16#6552cb60#;
   pragma Export (C, u00138, "ada__strings__unboundedS");
   u00139 : constant Version_32 := 16#acee74ad#;
   pragma Export (C, u00139, "system__compare_array_unsigned_8B");
   u00140 : constant Version_32 := 16#5944a997#;
   pragma Export (C, u00140, "system__compare_array_unsigned_8S");
   u00141 : constant Version_32 := 16#a8025f3c#;
   pragma Export (C, u00141, "system__address_operationsB");
   u00142 : constant Version_32 := 16#e34b6629#;
   pragma Export (C, u00142, "system__address_operationsS");
   u00143 : constant Version_32 := 16#a02f73f2#;
   pragma Export (C, u00143, "system__storage_pools__subpoolsB");
   u00144 : constant Version_32 := 16#cc5a1856#;
   pragma Export (C, u00144, "system__storage_pools__subpoolsS");
   u00145 : constant Version_32 := 16#57674f80#;
   pragma Export (C, u00145, "system__finalization_mastersB");
   u00146 : constant Version_32 := 16#abbbe1d0#;
   pragma Export (C, u00146, "system__finalization_mastersS");
   u00147 : constant Version_32 := 16#7268f812#;
   pragma Export (C, u00147, "system__img_boolB");
   u00148 : constant Version_32 := 16#059ea9f1#;
   pragma Export (C, u00148, "system__img_boolS");
   u00149 : constant Version_32 := 16#86c56e5a#;
   pragma Export (C, u00149, "ada__finalizationS");
   u00150 : constant Version_32 := 16#10558b11#;
   pragma Export (C, u00150, "ada__streamsB");
   u00151 : constant Version_32 := 16#67e31212#;
   pragma Export (C, u00151, "ada__streamsS");
   u00152 : constant Version_32 := 16#95817ed8#;
   pragma Export (C, u00152, "system__finalization_rootB");
   u00153 : constant Version_32 := 16#bfb5ab8a#;
   pragma Export (C, u00153, "system__finalization_rootS");
   u00154 : constant Version_32 := 16#6d4d969a#;
   pragma Export (C, u00154, "system__storage_poolsB");
   u00155 : constant Version_32 := 16#d3aa46b7#;
   pragma Export (C, u00155, "system__storage_poolsS");
   u00156 : constant Version_32 := 16#84042202#;
   pragma Export (C, u00156, "system__storage_pools__subpools__finalizationB");
   u00157 : constant Version_32 := 16#fe2f4b3a#;
   pragma Export (C, u00157, "system__storage_pools__subpools__finalizationS");
   u00158 : constant Version_32 := 16#020a3f4d#;
   pragma Export (C, u00158, "system__atomic_countersB");
   u00159 : constant Version_32 := 16#441bf597#;
   pragma Export (C, u00159, "system__atomic_countersS");
   u00160 : constant Version_32 := 16#039168f8#;
   pragma Export (C, u00160, "system__stream_attributesB");
   u00161 : constant Version_32 := 16#8bc30a4e#;
   pragma Export (C, u00161, "system__stream_attributesS");
   u00162 : constant Version_32 := 16#e1ac7275#;
   pragma Export (C, u00162, "system__file_attributesS");
   u00163 : constant Version_32 := 16#9a22cb7e#;
   pragma Export (C, u00163, "system__os_constantsS");
   u00164 : constant Version_32 := 16#ec9c64c3#;
   pragma Export (C, u00164, "system__file_ioB");
   u00165 : constant Version_32 := 16#5736397f#;
   pragma Export (C, u00165, "system__file_ioS");
   u00166 : constant Version_32 := 16#73d2d764#;
   pragma Export (C, u00166, "interfaces__c_streamsB");
   u00167 : constant Version_32 := 16#b1330297#;
   pragma Export (C, u00167, "interfaces__c_streamsS");
   u00168 : constant Version_32 := 16#0dd842b2#;
   pragma Export (C, u00168, "system__file_control_blockS");
   u00169 : constant Version_32 := 16#95f86c43#;
   pragma Export (C, u00169, "system__regexpB");
   u00170 : constant Version_32 := 16#d3757fd6#;
   pragma Export (C, u00170, "system__regexpS");
   u00171 : constant Version_32 := 16#abfcab7d#;
   pragma Export (C, u00171, "aliB");
   u00172 : constant Version_32 := 16#4f5456e6#;
   pragma Export (C, u00172, "aliS");
   u00173 : constant Version_32 := 16#c017f602#;
   pragma Export (C, u00173, "butilB");
   u00174 : constant Version_32 := 16#0d752381#;
   pragma Export (C, u00174, "butilS");
   u00175 : constant Version_32 := 16#b5988c27#;
   pragma Export (C, u00175, "gnatS");
   u00176 : constant Version_32 := 16#3299b26a#;
   pragma Export (C, u00176, "optB");
   u00177 : constant Version_32 := 16#5897096d#;
   pragma Export (C, u00177, "optS");
   u00178 : constant Version_32 := 16#dcf8e2cf#;
   pragma Export (C, u00178, "system__assertionsB");
   u00179 : constant Version_32 := 16#3dcaf48e#;
   pragma Export (C, u00179, "system__assertionsS");
   u00180 : constant Version_32 := 16#b9a3a899#;
   pragma Export (C, u00180, "tree_ioB");
   u00181 : constant Version_32 := 16#15844d9c#;
   pragma Export (C, u00181, "tree_ioS");
   u00182 : constant Version_32 := 16#91fc5baa#;
   pragma Export (C, u00182, "debugB");
   u00183 : constant Version_32 := 16#1ac546f9#;
   pragma Export (C, u00183, "debugS");
   u00184 : constant Version_32 := 16#39794d05#;
   pragma Export (C, u00184, "outputB");
   u00185 : constant Version_32 := 16#83393876#;
   pragma Export (C, u00185, "outputS");
   u00186 : constant Version_32 := 16#7db849eb#;
   pragma Export (C, u00186, "hostparmS");
   u00187 : constant Version_32 := 16#fd83e873#;
   pragma Export (C, u00187, "system__concat_2B");
   u00188 : constant Version_32 := 16#f2e70fca#;
   pragma Export (C, u00188, "system__concat_2S");
   u00189 : constant Version_32 := 16#587eb9ab#;
   pragma Export (C, u00189, "typesB");
   u00190 : constant Version_32 := 16#c499bf82#;
   pragma Export (C, u00190, "typesS");
   u00191 : constant Version_32 := 16#bbff9f5c#;
   pragma Export (C, u00191, "nametB");
   u00192 : constant Version_32 := 16#f1c61094#;
   pragma Export (C, u00192, "nametS");
   u00193 : constant Version_32 := 16#700bac7f#;
   pragma Export (C, u00193, "widecharB");
   u00194 : constant Version_32 := 16#700d44f3#;
   pragma Export (C, u00194, "widecharS");
   u00195 : constant Version_32 := 16#972e59bd#;
   pragma Export (C, u00195, "allocS");
   u00196 : constant Version_32 := 16#413de238#;
   pragma Export (C, u00196, "tableB");
   u00197 : constant Version_32 := 16#71c45158#;
   pragma Export (C, u00197, "tableS");
   u00198 : constant Version_32 := 16#e31b7c4e#;
   pragma Export (C, u00198, "system__memoryB");
   u00199 : constant Version_32 := 16#a93abe2e#;
   pragma Export (C, u00199, "system__memoryS");
   u00200 : constant Version_32 := 16#e909d55e#;
   pragma Export (C, u00200, "fnameB");
   u00201 : constant Version_32 := 16#06dc2a66#;
   pragma Export (C, u00201, "fnameS");
   u00202 : constant Version_32 := 16#2044a70d#;
   pragma Export (C, u00202, "gnat__dynamic_htablesB");
   u00203 : constant Version_32 := 16#05f952b6#;
   pragma Export (C, u00203, "gnat__dynamic_htablesS");
   u00204 : constant Version_32 := 16#17fb561a#;
   pragma Export (C, u00204, "osintB");
   u00205 : constant Version_32 := 16#e640ad21#;
   pragma Export (C, u00205, "osintS");
   u00206 : constant Version_32 := 16#c4507fa7#;
   pragma Export (C, u00206, "fmapB");
   u00207 : constant Version_32 := 16#9ac5a2f6#;
   pragma Export (C, u00207, "fmapS");
   u00208 : constant Version_32 := 16#be789e08#;
   pragma Export (C, u00208, "gnat__htableB");
   u00209 : constant Version_32 := 16#7a3e0440#;
   pragma Export (C, u00209, "gnat__htableS");
   u00210 : constant Version_32 := 16#b910cc1d#;
   pragma Export (C, u00210, "sdefaultB");
   u00211 : constant Version_32 := 16#a7d7201f#;
   pragma Export (C, u00211, "sdefaultS");
   u00212 : constant Version_32 := 16#40dce533#;
   pragma Export (C, u00212, "targparmB");
   u00213 : constant Version_32 := 16#24210956#;
   pragma Export (C, u00213, "targparmS");
   u00214 : constant Version_32 := 16#46a3369a#;
   pragma Export (C, u00214, "csetsB");
   u00215 : constant Version_32 := 16#e948558f#;
   pragma Export (C, u00215, "csetsS");
   u00216 : constant Version_32 := 16#27e30df3#;
   pragma Export (C, u00216, "ridentS");
   u00217 : constant Version_32 := 16#a19d6876#;
   pragma Export (C, u00217, "snamesB");
   u00218 : constant Version_32 := 16#2b47cd92#;
   pragma Export (C, u00218, "snamesS");
   u00219 : constant Version_32 := 16#cfbc3039#;
   pragma Export (C, u00219, "casingB");
   u00220 : constant Version_32 := 16#f1067a43#;
   pragma Export (C, u00220, "casingS");
   u00221 : constant Version_32 := 16#c0b19ae7#;
   pragma Export (C, u00221, "ali__utilB");
   u00222 : constant Version_32 := 16#cd7c7b7f#;
   pragma Export (C, u00222, "ali__utilS");
   u00223 : constant Version_32 := 16#a38bdc57#;
   pragma Export (C, u00223, "atreeB");
   u00224 : constant Version_32 := 16#32794950#;
   pragma Export (C, u00224, "atreeS");
   u00225 : constant Version_32 := 16#04c990f1#;
   pragma Export (C, u00225, "aspectsB");
   u00226 : constant Version_32 := 16#479df97c#;
   pragma Export (C, u00226, "aspectsS");
   u00227 : constant Version_32 := 16#186f7a0d#;
   pragma Export (C, u00227, "einfoB");
   u00228 : constant Version_32 := 16#6f09bdd8#;
   pragma Export (C, u00228, "einfoS");
   u00229 : constant Version_32 := 16#4ddf0b23#;
   pragma Export (C, u00229, "elistsB");
   u00230 : constant Version_32 := 16#066d7b5e#;
   pragma Export (C, u00230, "elistsS");
   u00231 : constant Version_32 := 16#1b6610ed#;
   pragma Export (C, u00231, "nlistsB");
   u00232 : constant Version_32 := 16#20cc779b#;
   pragma Export (C, u00232, "nlistsS");
   u00233 : constant Version_32 := 16#40954c32#;
   pragma Export (C, u00233, "sinfoB");
   u00234 : constant Version_32 := 16#d099103f#;
   pragma Export (C, u00234, "sinfoS");
   u00235 : constant Version_32 := 16#92a723ac#;
   pragma Export (C, u00235, "uintpB");
   u00236 : constant Version_32 := 16#20eb23c2#;
   pragma Export (C, u00236, "uintpS");
   u00237 : constant Version_32 := 16#b13f2662#;
   pragma Export (C, u00237, "urealpB");
   u00238 : constant Version_32 := 16#fcb52a52#;
   pragma Export (C, u00238, "urealpS");
   u00239 : constant Version_32 := 16#3cda6915#;
   pragma Export (C, u00239, "standB");
   u00240 : constant Version_32 := 16#97e61926#;
   pragma Export (C, u00240, "standS");
   u00241 : constant Version_32 := 16#8539d2d8#;
   pragma Export (C, u00241, "sinputB");
   u00242 : constant Version_32 := 16#6f2f2768#;
   pragma Export (C, u00242, "sinputS");
   u00243 : constant Version_32 := 16#f546f02e#;
   pragma Export (C, u00243, "gnat__byte_order_markB");
   u00244 : constant Version_32 := 16#9e8b3c0b#;
   pragma Export (C, u00244, "gnat__byte_order_markS");
   u00245 : constant Version_32 := 16#c34fe37c#;
   pragma Export (C, u00245, "scansB");
   u00246 : constant Version_32 := 16#5f34a5f0#;
   pragma Export (C, u00246, "scansS");
   u00247 : constant Version_32 := 16#dd938547#;
   pragma Export (C, u00247, "binderrB");
   u00248 : constant Version_32 := 16#070d98dd#;
   pragma Export (C, u00248, "binderrS");
   u00249 : constant Version_32 := 16#fbb8363e#;
   pragma Export (C, u00249, "err_varsS");
   u00250 : constant Version_32 := 16#8a1a8848#;
   pragma Export (C, u00250, "restrictB");
   u00251 : constant Version_32 := 16#4d64c5da#;
   pragma Export (C, u00251, "restrictS");
   u00252 : constant Version_32 := 16#eed4cb97#;
   pragma Export (C, u00252, "erroutB");
   u00253 : constant Version_32 := 16#075d0f1e#;
   pragma Export (C, u00253, "erroutS");
   u00254 : constant Version_32 := 16#02f590fe#;
   pragma Export (C, u00254, "erroutcB");
   u00255 : constant Version_32 := 16#34c69e85#;
   pragma Export (C, u00255, "erroutcS");
   u00256 : constant Version_32 := 16#092ce8de#;
   pragma Export (C, u00256, "stringtB");
   u00257 : constant Version_32 := 16#ca568eb6#;
   pragma Export (C, u00257, "stringtS");
   u00258 : constant Version_32 := 16#9a737387#;
   pragma Export (C, u00258, "libB");
   u00259 : constant Version_32 := 16#805e10cc#;
   pragma Export (C, u00259, "libS");
   u00260 : constant Version_32 := 16#a4214150#;
   pragma Export (C, u00260, "unameB");
   u00261 : constant Version_32 := 16#7ba289ea#;
   pragma Export (C, u00261, "unameS");
   u00262 : constant Version_32 := 16#999198a6#;
   pragma Export (C, u00262, "sem_auxB");
   u00263 : constant Version_32 := 16#9f4dc9af#;
   pragma Export (C, u00263, "sem_auxS");
   u00264 : constant Version_32 := 16#933d538f#;
   pragma Export (C, u00264, "styleswB");
   u00265 : constant Version_32 := 16#bce761ee#;
   pragma Export (C, u00265, "styleswS");
   u00266 : constant Version_32 := 16#73c1f60f#;
   pragma Export (C, u00266, "fname__ufB");
   u00267 : constant Version_32 := 16#76bbb8a3#;
   pragma Export (C, u00267, "fname__ufS");
   u00268 : constant Version_32 := 16#997d3593#;
   pragma Export (C, u00268, "krunchB");
   u00269 : constant Version_32 := 16#c0b4ff65#;
   pragma Export (C, u00269, "krunchS");
   u00270 : constant Version_32 := 16#d642a37a#;
   pragma Export (C, u00270, "scngB");
   u00271 : constant Version_32 := 16#5f4ca81a#;
   pragma Export (C, u00271, "scngS");
   u00272 : constant Version_32 := 16#1c868fea#;
   pragma Export (C, u00272, "system__crc32B");
   u00273 : constant Version_32 := 16#495502b5#;
   pragma Export (C, u00273, "system__crc32S");
   u00274 : constant Version_32 := 16#27ccf663#;
   pragma Export (C, u00274, "system__utf_32B");
   u00275 : constant Version_32 := 16#6ece31d6#;
   pragma Export (C, u00275, "system__utf_32S");
   u00276 : constant Version_32 := 16#3f14c101#;
   pragma Export (C, u00276, "stylegB");
   u00277 : constant Version_32 := 16#a75c9028#;
   pragma Export (C, u00277, "stylegS");
   u00278 : constant Version_32 := 16#702f0136#;
   pragma Export (C, u00278, "sinput__cB");
   u00279 : constant Version_32 := 16#ae235f22#;
   pragma Export (C, u00279, "sinput__cS");
   u00280 : constant Version_32 := 16#eb387c00#;
   pragma Export (C, u00280, "fname__sfB");
   u00281 : constant Version_32 := 16#ee92d97e#;
   pragma Export (C, u00281, "fname__sfS");
   u00282 : constant Version_32 := 16#deaf9cc1#;
   pragma Export (C, u00282, "sfn_scanB");
   u00283 : constant Version_32 := 16#fb1d0fa7#;
   pragma Export (C, u00283, "sfn_scanS");
   u00284 : constant Version_32 := 16#eccb5605#;
   pragma Export (C, u00284, "gnat__command_lineB");
   u00285 : constant Version_32 := 16#0b5ceadc#;
   pragma Export (C, u00285, "gnat__command_lineS");
   u00286 : constant Version_32 := 16#f4e097a7#;
   pragma Export (C, u00286, "ada__text_ioB");
   u00287 : constant Version_32 := 16#c10f6737#;
   pragma Export (C, u00287, "ada__text_ioS");
   u00288 : constant Version_32 := 16#2553ed92#;
   pragma Export (C, u00288, "gnat__directory_operationsB");
   u00289 : constant Version_32 := 16#3968614f#;
   pragma Export (C, u00289, "gnat__directory_operationsS");
   u00290 : constant Version_32 := 16#efb85c8a#;
   pragma Export (C, u00290, "gnat__os_libS");
   u00291 : constant Version_32 := 16#5a895de2#;
   pragma Export (C, u00291, "system__pool_globalB");
   u00292 : constant Version_32 := 16#7141203e#;
   pragma Export (C, u00292, "system__pool_globalS");
   u00293 : constant Version_32 := 16#40fe4806#;
   pragma Export (C, u00293, "gnat__regexpS");
   u00294 : constant Version_32 := 16#fcd606d0#;
   pragma Export (C, u00294, "gnat__stringsS");
   u00295 : constant Version_32 := 16#ed5db588#;
   pragma Export (C, u00295, "make_utilB");
   u00296 : constant Version_32 := 16#42f03ed0#;
   pragma Export (C, u00296, "make_utilS");
   u00297 : constant Version_32 := 16#4179c767#;
   pragma Export (C, u00297, "errutilB");
   u00298 : constant Version_32 := 16#d39ec004#;
   pragma Export (C, u00298, "errutilS");
   u00299 : constant Version_32 := 16#d37ed4a2#;
   pragma Export (C, u00299, "gnat__case_utilB");
   u00300 : constant Version_32 := 16#857fd105#;
   pragma Export (C, u00300, "gnat__case_utilS");
   u00301 : constant Version_32 := 16#0a7369ff#;
   pragma Export (C, u00301, "makeusgB");
   u00302 : constant Version_32 := 16#d11a0f72#;
   pragma Export (C, u00302, "makeusgS");
   u00303 : constant Version_32 := 16#a88c6d24#;
   pragma Export (C, u00303, "switchB");
   u00304 : constant Version_32 := 16#cb06ad41#;
   pragma Export (C, u00304, "switchS");
   u00305 : constant Version_32 := 16#b0eef1a7#;
   pragma Export (C, u00305, "usageB");
   u00306 : constant Version_32 := 16#44182068#;
   pragma Export (C, u00306, "usageS");
   u00307 : constant Version_32 := 16#80ee1fe5#;
   pragma Export (C, u00307, "osint__mB");
   u00308 : constant Version_32 := 16#eac35f3e#;
   pragma Export (C, u00308, "osint__mS");
   u00309 : constant Version_32 := 16#b20655b4#;
   pragma Export (C, u00309, "switch__mB");
   u00310 : constant Version_32 := 16#36e46ca4#;
   pragma Export (C, u00310, "switch__mS");
   u00311 : constant Version_32 := 16#f65595cf#;
   pragma Export (C, u00311, "system__multiprocessorsB");
   u00312 : constant Version_32 := 16#c8eb4769#;
   pragma Export (C, u00312, "system__multiprocessorsS");
   u00313 : constant Version_32 := 16#9d1d7df2#;
   pragma Export (C, u00313, "tempdirB");
   u00314 : constant Version_32 := 16#51e2824e#;
   pragma Export (C, u00314, "tempdirS");

   --  BEGIN ELABORATION ORDER
   --  ada%s
   --  ada.characters%s
   --  ada.characters.latin_1%s
   --  interfaces%s
   --  system%s
   --  system.address_operations%s
   --  system.address_operations%b
   --  system.atomic_counters%s
   --  system.atomic_counters%b
   --  system.exn_llf%s
   --  system.exn_llf%b
   --  system.float_control%s
   --  system.float_control%b
   --  system.img_bool%s
   --  system.img_bool%b
   --  system.img_int%s
   --  system.img_int%b
   --  system.io%s
   --  system.io%b
   --  system.os_primitives%s
   --  system.os_primitives%b
   --  system.parameters%s
   --  system.parameters%b
   --  system.crtl%s
   --  interfaces.c_streams%s
   --  interfaces.c_streams%b
   --  system.storage_elements%s
   --  system.storage_elements%b
   --  system.stack_checking%s
   --  system.stack_checking%b
   --  system.string_hash%s
   --  system.string_hash%b
   --  system.htable%s
   --  system.htable%b
   --  system.strings%s
   --  system.strings%b
   --  system.traceback_entries%s
   --  system.traceback_entries%b
   --  system.unsigned_types%s
   --  system.img_uns%s
   --  system.img_uns%b
   --  system.utf_32%s
   --  system.utf_32%b
   --  system.wch_con%s
   --  system.wch_con%b
   --  system.wch_jis%s
   --  system.wch_jis%b
   --  system.wch_cnv%s
   --  system.wch_cnv%b
   --  system.compare_array_unsigned_8%s
   --  system.compare_array_unsigned_8%b
   --  system.concat_2%s
   --  system.concat_2%b
   --  system.crc32%s
   --  system.crc32%b
   --  system.traceback%s
   --  system.traceback%b
   --  ada.characters.handling%s
   --  system.case_util%s
   --  system.os_lib%s
   --  system.secondary_stack%s
   --  system.standard_library%s
   --  ada.exceptions%s
   --  system.exceptions_debug%s
   --  system.exceptions_debug%b
   --  system.soft_links%s
   --  system.val_lli%s
   --  system.val_llu%s
   --  system.val_util%s
   --  system.val_util%b
   --  system.wch_stw%s
   --  system.wch_stw%b
   --  ada.exceptions.last_chance_handler%s
   --  ada.exceptions.last_chance_handler%b
   --  ada.exceptions.traceback%s
   --  ada.exceptions.traceback%b
   --  system.address_image%s
   --  system.address_image%b
   --  system.bit_ops%s
   --  system.bit_ops%b
   --  system.bounded_strings%s
   --  system.bounded_strings%b
   --  system.case_util%b
   --  system.exception_table%s
   --  system.exception_table%b
   --  ada.containers%s
   --  ada.io_exceptions%s
   --  ada.strings%s
   --  ada.strings.maps%s
   --  ada.strings.maps%b
   --  ada.strings.maps.constants%s
   --  interfaces.c%s
   --  interfaces.c%b
   --  system.exceptions%s
   --  system.exceptions%b
   --  system.exceptions.machine%s
   --  system.exceptions.machine%b
   --  ada.characters.handling%b
   --  system.exception_traces%s
   --  system.exception_traces%b
   --  system.memory%s
   --  system.memory%b
   --  system.mmap%s
   --  system.mmap.os_interface%s
   --  system.mmap%b
   --  system.mmap.unix%s
   --  system.mmap.os_interface%b
   --  system.object_reader%s
   --  system.object_reader%b
   --  system.dwarf_lines%s
   --  system.dwarf_lines%b
   --  system.os_lib%b
   --  system.secondary_stack%b
   --  system.soft_links.initialize%s
   --  system.soft_links.initialize%b
   --  system.soft_links%b
   --  system.standard_library%b
   --  system.traceback.symbolic%s
   --  system.traceback.symbolic%b
   --  ada.exceptions%b
   --  system.val_lli%b
   --  system.val_llu%b
   --  ada.command_line%s
   --  ada.command_line%b
   --  ada.strings.search%s
   --  ada.strings.search%b
   --  ada.strings.fixed%s
   --  ada.strings.fixed%b
   --  ada.tags%s
   --  ada.tags%b
   --  ada.streams%s
   --  ada.streams%b
   --  gnat%s
   --  gnat.case_util%s
   --  gnat.case_util%b
   --  gnat.htable%s
   --  gnat.htable%b
   --  gnat.os_lib%s
   --  gnat.strings%s
   --  system.file_control_block%s
   --  system.finalization_root%s
   --  system.finalization_root%b
   --  ada.finalization%s
   --  system.file_io%s
   --  system.file_io%b
   --  system.multiprocessors%s
   --  system.multiprocessors%b
   --  system.os_constants%s
   --  system.storage_pools%s
   --  system.storage_pools%b
   --  system.finalization_masters%s
   --  system.finalization_masters%b
   --  system.storage_pools.subpools%s
   --  system.storage_pools.subpools.finalization%s
   --  system.storage_pools.subpools.finalization%b
   --  system.storage_pools.subpools%b
   --  system.stream_attributes%s
   --  system.stream_attributes%b
   --  ada.strings.unbounded%s
   --  ada.strings.unbounded%b
   --  system.val_real%s
   --  system.val_real%b
   --  system.val_uns%s
   --  system.val_uns%b
   --  system.val_int%s
   --  system.val_int%b
   --  ada.calendar%s
   --  ada.calendar%b
   --  ada.calendar.time_zones%s
   --  ada.calendar.time_zones%b
   --  ada.calendar.formatting%s
   --  ada.calendar.formatting%b
   --  ada.text_io%s
   --  ada.text_io%b
   --  gnat.byte_order_mark%s
   --  gnat.byte_order_mark%b
   --  gnat.directory_operations%s
   --  gnat.directory_operations%b
   --  gnat.dynamic_htables%s
   --  gnat.dynamic_htables%b
   --  system.assertions%s
   --  system.assertions%b
   --  system.file_attributes%s
   --  system.pool_global%s
   --  system.pool_global%b
   --  system.regexp%s
   --  system.regexp%b
   --  ada.directories%s
   --  ada.directories.hierarchical_file_names%s
   --  ada.directories.validity%s
   --  ada.directories.validity%b
   --  ada.directories%b
   --  ada.directories.hierarchical_file_names%b
   --  gnat.regexp%s
   --  gnat.command_line%s
   --  gnat.command_line%b
   --  debug%s
   --  debug%b
   --  types%s
   --  types%b
   --  alloc%s
   --  gnatvsn%s
   --  gnatvsn%b
   --  hostparm%s
   --  krunch%s
   --  krunch%b
   --  output%s
   --  output%b
   --  rident%s
   --  sfn_scan%s
   --  sfn_scan%b
   --  tree_io%s
   --  tree_io%b
   --  opt%s
   --  opt%b
   --  csets%s
   --  csets%b
   --  stylesw%s
   --  stylesw%b
   --  table%s
   --  table%b
   --  elists%s
   --  elists%b
   --  stand%s
   --  stand%b
   --  uintp%s
   --  uintp%b
   --  urealp%s
   --  urealp%b
   --  widechar%s
   --  widechar%b
   --  namet%s
   --  namet%b
   --  butil%s
   --  butil%b
   --  binderr%s
   --  binderr%b
   --  casing%s
   --  casing%b
   --  err_vars%s
   --  fmap%s
   --  osint%s
   --  fmap%b
   --  sdefault%s
   --  sdefault%b
   --  targparm%s
   --  targparm%b
   --  osint%b
   --  fname%s
   --  fname%b
   --  osint.m%s
   --  osint.m%b
   --  snames%s
   --  snames%b
   --  ali%s
   --  ali%b
   --  scans%s
   --  scans%b
   --  aspects%s
   --  einfo%s
   --  nlists%s
   --  sinfo%s
   --  atree%s
   --  aspects%b
   --  einfo%b
   --  nlists%b
   --  sinfo%b
   --  sinput%s
   --  sinput%b
   --  atree%b
   --  sem_aux%s
   --  sem_aux%b
   --  sinput.c%s
   --  sinput.c%b
   --  stringt%s
   --  stringt%b
   --  erroutc%s
   --  erroutc%b
   --  lib%s
   --  uname%s
   --  uname%b
   --  lib%b
   --  errout%s
   --  errout%b
   --  fname.uf%s
   --  fname.uf%b
   --  fname.sf%s
   --  fname.sf%b
   --  restrict%s
   --  restrict%b
   --  styleg%s
   --  styleg%b
   --  errutil%s
   --  errutil%b
   --  make_util%s
   --  make_util%b
   --  scng%s
   --  scng%b
   --  ali.util%s
   --  ali.util%b
   --  switch%s
   --  switch%b
   --  switch.m%s
   --  switch.m%b
   --  tempdir%s
   --  tempdir%b
   --  usage%s
   --  usage%b
   --  makeusg%s
   --  makeusg%b
   --  make%s
   --  make%b
   --  gnatmake%s
   --  gnatmake%b
   --  END ELABORATION ORDER

end ada_main;
